/*
FileName:AdminAgileSquad.js
Version:1.0.0
Purpose:Getting the List of all the employees list 
Developers:Mahesh Reddy, NaveenKumar Gade(GNK) 
*/
import React, { Component } from 'react';
import { Platform, Linking, StyleSheet, Text, FlatList, TouchableOpacity, Picker, View, StatusBar, Dimensions, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Subtitle, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import AsyncStorage from '@react-native-community/async-storage';
import Icon from 'react-native-vector-icons/FontAwesome';
import Communications from 'react-native-communications';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import DropDownPicker from 'react-native-dropdown-picker';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import { SwipeListView } from 'react-native-swipe-list-view';
import { NavigationEvents } from 'react-navigation';
import jwt_decode from "jwt-decode";
import Main from '../Maintenance/Main';
const check = new Main()
import UserDatabase from '../OfflineDB/UserDatabase';
import { MANAGEEMPLOYEES, EMAIL, MOBILE, CONTACT, EMAILUSERNAME, ADDEMPLOYEE } from '../CommonComponents/Header';

const db = new UserDatabase();
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';

class ListItem extends Component {

    constructor(props) {
        super(props);
        this.state = {
            // isLoading: true,
            dataSource: [],
            dataSource2: [],
            roledata: '',
            sendBy: '',
            resource: [],
            // expanded: false,
        }

        this.getMessages();
        this.getShifts();
    }

    getMessages() {
        log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
        // const groupId = this.state.subtaskId;
        // console.warn("getmessages");
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            this.setState({ userid: userToken });
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                // console.warn("userToken"+userToken)
                // console.warn("cropcode"+cropcode)

                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    }
                    else {
                        fetch(API + "user_chat.php",
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({

                                    action: "get_all_messages",
                                    corp_code: cropcode,
                                    sendBy: userToken,
                                    projectId: projectId,


                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn("Messages For chat application" + JSON.stringify(responseJson.data));

                                // console.warn("Messages from users" + JSON.stringify(responseJson))
                                // console.warn("Send By Name" + JSON.stringify(responseJson.data))
                                if (responseJson.status === 'True') {

                                    console.warn("Setted Data")



                                    this.setState({
                                        dataSource2: responseJson.data,
                                    });
                                    console.warn("Method data" + responseJson.data.sendBy)
                                }
                                else {
                                    console.warn("Empty  Data")
                                    this.setState({
                                        dataSource: '',
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "getting task related messages error");
                            });

                    }
                });
            });
        });
    }



    // delete Employee start
    deleteAction(email, empid) {
        // alert("delete"+item)
        // alert(email+""+empid)
        log("Info", "UserManageEmployees:deleteAction(item, index) method is used to give alert");
        Alert.alert(
            'Alert..!',
            'Do you want to Deactive User',
            [
                {
                    text: 'Cancel',
                    onPress: () => console.log('Cancel Pressed'),
                    style: 'cancel',
                },
                { text: 'OK', onPress: () => this.deleteEmployee(email, empid) },
            ],
            { cancelable: false },
        );
    }
    //delete Employee end

    //delete the Emmployee
    deleteEmployee(email, empid) {
        //alert("Helllo");
        // alert(email)
        log("Info", "UserManageEmployees:deleteEmployee() method is used to delete employee");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    // console.warn(item)
                    // alert(this.state.email)
                    fetch(API + 'manage_user.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            empId: empid,
                            corp: crop,
                            action: 'deactivate_user',
                            // username: email,

                        })
                    }).then((response) => response.json())
                        .then((responseJson) => {
                            console.log(JSON.stringify(responseJson));
                            console.log(responseJson);
                            alert(JSON.stringify(responseJson))

                            if (responseJson.status === 'True') {
                                // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                                console.log("done")
                                // this.deactiveEmployee(email);
                                // alert(responseJson.message);
                                //alert("Employee is Deleted");
                                //this.refs.toast.showBottom('Employee is Deleted');

                                this.setState({ open: false })
                                // this.props.navigation.navigate('UserManageEmployees');
                                // this.UserManageEmployees();
                            }
                            else {
                                // alert("Hello111");
                                // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                            }
                        }).catch((error) => {
                            console.error(error);
                            // alert("Hello");
                            log("Error", "error in employee deletion");
                        });
                }
            });
        });
    };
    //Delete Employee end

    // Active Employee start
    activeAction(email, empid) {
        // alert("delete"+item)
        // alert(email+""+empid)
        log("Info", "UserManageEmployees:actAcivetion(item, index) method is used to give alert");
        Alert.alert(
            'Alert..!',
            'Do you want to Active User',
            [
                {
                    text: 'Cancel',
                    onPress: () => console.log('Cancel Pressed'),
                    style: 'cancel',
                },
                { text: 'OK', onPress: () => this.activeEmployee(email, empid) },
            ],
            { cancelable: false },
        );
    }
    //Active Employee end

    //Active the Emmployee
    activeEmployee(email, empid) {
        //alert("Helllo");
        // alert(email)
        log("Info", "UserManageEmployees:deleteEmployee() method is used to delete employee");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    // console.warn(item)
                    // alert(this.state.email)
                    fetch(API + 'manage_user.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            empId: empid,
                            corp: crop,
                            action: 'activate_user',
                            // username: email,

                        })
                    }).then((response) => response.json())
                        .then((responseJson) => {
                            console.log(JSON.stringify(responseJson));
                            console.log(responseJson);

                            if (responseJson.status === 'True') {
                                // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                                console.log("done")
                                // this.deactiveEmployee(email);
                                // alert(responseJson.message);
                                //alert("Employee is Deleted");
                                //this.refs.toast.showBottom('Employee is Deleted');

                                this.setState({ open: false })
                                // this.props.navigation.navigate('UserManageEmployees');
                                // this.UserManageEmployees();
                            }
                            else {
                                // alert("Hello111");
                                // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                            }
                        }).catch((error) => {
                            console.error(error);
                            // alert("Hello");
                            log("Error", "error in employee deletion");
                        });
                }
            });
        });
    };
    //Active Employee end




    //delete the Emmployee
    deactiveEmployee(email) {
        //alert("Helllo");
        // alert(email)
        log("Info", "UserManageEmployees:deleteEmployee() method is used to delete employee dataaaaa");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    // console.warn(item)
                    // alert(email)
                    fetch(API + 'squadStatus.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            // empid: item,
                            corp: crop,
                            action: 'deactivate',
                            username: email,

                        })
                    }).then((response) => response.json())
                        .then((responseJson) => {
                            // console.log(JSON.stringify(responseJson));
                            console.log("Testing" + responseJson);

                            if (responseJson.status === 'true') {
                                // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                                console.log("done")
                                // alert(responseJson.message);
                                //alert("Employee is Deleted");
                                //this.refs.toast.showBottom('Employee is Deleted');

                                this.setState({ open: false })
                                // this.props.navigation.navigate('UserManageEmployees');
                                // this.UserManageEmployees();
                            }
                            else {
                                alert("Hello111");
                                // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                            }
                        }).catch((error) => {
                            console.error(error);
                            alert("Hello");
                            log("Error", "error in employee deletion");
                        });
                }
            });
        });
    };


    //getting the Employees list for addind maintask
    getShifts() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");

        AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;
            // alert(projectId)

            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                // alert(cropcode)
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'get_user_shifts.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({

                                    action: "get_shifts",


                                })
                            })
                            .then((response) => response.json())

                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson))
                                if (responseJson.status === 'True') {
                                    console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                                    // alert(JSON.stringify(responseJson))
                                    var sprintDetails = [];

                                    responseJson.data.map((sprints) => {

                                        return (
                                            sprintDetails.push({ 'key': sprints.ts_id, 'label': sprints.start_time + " - " + sprints.end_time + " " + sprints.time_zone })
                                        );
                                    })
                                    // this.addOfflineSprints(sprintDetails, cropcode)//Store Sprint List in Offline
                                    this.setState({
                                        resource: sprintDetails
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }
    // Update Status of Employee
    UpdateStatus1(shift_id, empid) {
        // alert(shift_id)
        // alert(empid)
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus1(status) method is used to update status of employee");
        // console.warn("Hello" + squadName);

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;



                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        // this.setState({
                        //     timeData: timeData
                        // });
                        // AsyncStorage.setItem('cropcode', squadName);
                        // this.getOfflineSprints()//Getting the List of offline Sprints
                        // this.getOfflineActiveSprints("currentsprint") //Getting Current Sprint Backlogs in offline
                        //for offline project switching end
                    } else {

                        fetch(API + 'get_user_shifts.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                emp_id: empid,
                                shift_id: shift_id,
                                action: "update_user_shift",


                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson))
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'True') {

                                    alert(responseJson.message)
                                    this.props.navigation.navigate('AdminAgileSquad');
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    // this.setState({

                                    //     timeData: timeData
                                    // });
                                    //  alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }
    render() {



        const { item } = this.props;
        const { emp_role } = this.props;
        // alert(emp_role)

        let button;

        if (emp_role === "Emp") {

            const { item } = this.props;
            button = null;
            // button =
            //   <TouchableOpacity style={{ marginTop: 12 }}
            //     onPress={() => this.props.navigation.navigate("EmployeeInfo", {
            //       empId: item.id,
            //       name: item.name,
            //       mobile: item.mobileNumber,
            //       email: item.email,
            //       designation: item.designation,
            //       userName: item.userName,
            //       team: item.team,
            //       empStatus: item.empStatus,
            //       workingStatus: item.workingStatus,
            //       role: item.role,


            //     })}>
            //     <Icon name="chevron-right" style={{ color: '#808080', paddingRight: 5 }} size={20} />
            //   </TouchableOpacity>
        } else {

            const { item } = this.props;
            button =
                <TouchableOpacity style={{ marginTop: 12 }}
                    // onPress={() => this.props.navigation.navigate("EmployeeInfo", {
                    onPress={() => this.props.navigation.navigate("EditUser", {
                        empId: item.id,
                        name: item.name,
                        mobile: item.mobileNumber,
                        email: item.email,
                        designation: item.designation,
                        userName: item.userName,
                        team: item.team,
                        empStatus: item.empStatus,
                        workingStatus: item.workingStatus,
                        role: item.role,
                        functionalManager: item.functionalManager,
                        reportingManager: item.reportingManager,

                    })}>
                    {/* <Icon name="chevron-right" style={{ color: '#808080', paddingRight: 5 }} size={20} /> */}
                </TouchableOpacity>
        }

        let button4;

        if (item.role === "Contributor") {

            const { item } = this.props;
            button4 = <Text style={styles.designationText}>Contributer</Text>;
        }
        else if (item.role === "Scrum Master") {

            const { item } = this.props;
            button4 = <Text style={styles.designationText}>Scrum Master</Text>;
        }
        else {

            const { item } = this.props;
            button4 =
                <Text style={styles.designationText}>Product Owner</Text>
        }

        //     <i>
        //     {msgCount.length > 0 ? msgCount.length : null}
        //     {
        //         msgCount.length > 0 ?
        //             <img src="images/common/chat.svg" alt="logo" style={{ width: '20px', height: '20px', backgroundColor: 'green' }} onClick={(event) => handleOpen(data, "UserChat")} />
        //             :
        //             <img src="images/common/chat.svg" alt="logo" style={{ width: '20px', height: '20px' }} onClick={(event) => handleOpen(data, "UserChat")} />

        //     }
        // </i>
        let button1;
        // if (this.state.emp_role === "Emp" || "Manager" || "Approver") {
        button1 = <TouchableOpacity style={{ marginTop: 12 }}
            onPress={() => this.props.navigation.navigate("UserChat", {
                empId: item.id,
                // action:"send"
                name: item.name,
                // mobile: item.mobileNumber,
                // email: item.email,
                // designation: item.designation,
                // userName: item.userName,
                // team: item.team,
                // empStatus: item.empStatus,
                // workingStatus: item.workingStatus,
                // role: item.role
            })}>
            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} />
        </TouchableOpacity>

        // let button2;
        // // alert(sendBy)
        // console.warn("Checking name"+item.sendBy)
        // console.warn("sendBy"+item.sendBy==="Empid"+iteAdminAgileSquadm.id)
        // if (sendBy===item.id){
        //   // alert(data.item.sendBy)
        //   console.warn("sendBy"+sendBy==="Empid"+item.id);
        //   button2=<Text>Hello</Text>
        // }
        // else{
        //   // alert(data.item.sendBy)
        //   console.warn("sendBy"+sendBy==="Empid"+item.id);
        //   button2=<Text>Friend</Text>
        // }

        let button6;
        if (this.state.emp_role === "admin") {
            button6 = null;
        } else {
            button6 =

                <TouchableOpacity onPress={() => this.deleteAction(item.email, item.id)}>
                    <Icon name="trash-o" style={{ color: 'red', marginLeft: 20, marginTop: 12 }} size={18} />
                </TouchableOpacity>
        }
        // var data1=this.state.dataSource1;
        const getMessagesCount = (data1, id) => {
            //  console.warn("ids"+JSON.stringify(data1) +id)

            //  var msg=this.state.dataSource1;
            // console.warn("Datasource and id send by"+JSON.stringify(data1.sendBy))
            let msgCount = data1.filter(message => message.sendBy === id).map((messages, i) => {
                return i

            })

            // console.warn("iiiiiiii" + msgCount)

            return (
                // console.warn("iiiiiiii" + msgCount),
                <View>
                    <Text style={{ color: 'green' }}> {msgCount.length > 0 ? msgCount.length : null} </Text>
                    {/* {msgCount.length > 0 ? msgCount.length : null} */}
                    {
                        msgCount.length > 0 ?

                            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} onPress={() => this.props.navigation.navigate("UserChat", {
                                empId: item.id,
                                name: item.name,


                            })} />

                            :
                            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} onPress={() => this.props.navigation.navigate("UserChat", {
                                empId: item.id,
                                name: item.name,


                            })} />


                    }

                </View>
            )

        }

        let buttonActive;
        if (item.workingStatus === "1") {
            buttonActive = <View style={{marginTop:5,marginLeft:'55%'}}><Text onPress={() => this.deleteAction(item.email, item.id)} style={{backgroundColor:'green',width:50,height:20,color:'white',justifyContent:'center',textAlign:'center'}}>Active</Text></View>
        }
        else {
            buttonActive = <View style={{marginTop:5,marginLeft:'55%'}}><Text onPress={() => this.activeAction(item.email, item.id)} style={{backgroundColor:'red',width:60,height:20,color:'white',justifyContent:'center',textAlign:'center'}}>InActive</Text></View>
        }
        return (

            <View style={styles.container}>
                <View style={styles.signup}>
                    <View style={[styles.buttonContainer, styles.signupButton]} >
                        <View style={styles.box}>
                            <View style={{ flexDirection: 'row' }}>
                                <Text style={styles.signUpText1} >{item.name}</Text>
                            </View>
                            {getMessagesCount(this.state.dataSource2, item.id)}
                            {/* {button4} */}
                        </View>
                        <View style={{ flexDirection: 'row', }}>
                            <View style={{ flexDirection: 'row', width: wp('90%') }}>
                                <Text style={styles.signUpText11}>{EMAILUSERNAME} : </Text>
                                <TouchableOpacity style={{ flexDirection: 'row' }}>
                                    <Icon name="envelope" style={{ color: 'red', marginLeft: 5, marginTop: 5 }} size={25}
                                        onPress={(item) => Linking.openURL('mailto:' + (item.email))} />
                                </TouchableOpacity>
                                <Text style={styles.signUpText11email}
                                    onPress={() => Linking.openURL('mailto:' + (item.email))}
                                >{item.email}</Text>

                            </View>
                            <View>
                                {button}
                            </View>
                        </View>

                    </View>
                    <View style={{ flexDirection: 'row' }}>
                        <View style={{ width: '30%', flexDirection: 'row' }}>
                            <Text style={styles.signUpText11}>{CONTACT} : </Text>

                            <TouchableOpacity style={{ flexDirection: 'row' }}>
                                <Icon name="phone" style={{ color: '#00FF00', marginLeft: 5, marginTop: 10 }} size={20}
                                    onPress={() => Communications.phonecall(item.mobileNumber, true)} />
                                <Text style={styles.signUpText11mobile}
                                    onPress={() => Communications.phonecall(item.mobileNumber, true)}
                                >{item.mobileNumber}</Text>
                            </TouchableOpacity>

                        </View>
                        {buttonActive}

                        {/* <Text style={{ marginTop: 10, }}>{item.workingStatus}</Text> */}
                    </View>
                    <View style={{ flexDirection: 'row', margin: 10 }}>
                        <ModalSelector
                            style={{ width: "100%", backgroundColor: 'transparent', borderColor: 'black', borderWidth: 0.5, borderRadius: 20, }}
                            data={this.state.resource}
                            initValue={this.state.shift_hours}
                            optionContainerStyle={{ backgroundColor: 'white' }}
                            onChange={(itemValue) => {
                                this.UpdateStatus1(itemValue.label, item.id),
                                    this.setState({
                                        // moduleId: itemValue.key,
                                        shift_hours: itemValue.label,

                                    })
                            }}

                        >

                            <View style={{ width: 300, borderRadius: 20, height: 45, flexDirection: 'row', borderColor: 'black', }}>
                                <Text style={{ marginTop: 5, color: 'black', width: 120, padding: 8 }}>Working Hours : </Text>

                                <Text style={{ marginTop: 5, color: 'black', width: 200, padding: 8 }}>{item.shift_hours}</Text>

                                <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 5, }}
                                />
                            </View>

                        </ModalSelector>
                    </View>

                    <View
                        style={{
                            marginTop: 15,
                            borderBottomColor: '#C0C0C0',
                            borderBottomWidth: 0.2,
                        }}
                    />
                </View>


            </View>
        )
    }
}
export default class AdminAgileSquad extends Component {

    constructor(props) {
        super(props);
        props.navigation.setParams({
            onTabFocus: this.handleTabFocus
        });
        let button;
        this.state = {
            isLoading: true,
            dataSource: [],
            dataSource1: [],
            isFetching: false,
            result: '',
            emp_role: '',
            squadName: '',


        }
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
        this.arrayholder = [];
        this.button = button;


    }
    // handleTabFocus = () => {
    //   this.onRefresh();
    // };

    componentDidMount() {
        log("Debug", "Employees list getting screen is loaded at user side");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
                this.getAgileProjects();

            } else {
                //to get the lsit of list of employees
                this.UserManageEmployees()
                this.GetStatus();
                this.getShifts();
                // this.getMessages();
            }
        });

        AsyncStorage.getItem("emp_role", (err, res) => {
            console.log(res)
            const emp_role1 = res;
            this.setState({ emp_role: emp_role1 })
        })
        AsyncStorage.getItem("userToken", (err, res) => {
            console.warn("empId" + res)
            const userToken = res;
            this.setState({ userToken: userToken })
        })
    }

    //For store Agile projects for offline Start
    addAgileProjects(data) {
        console.warn("hello naveen" + JSON.stringify(data));
        db.addAgileProjects(data).then((result) => {
            console.log(result);
        }).catch((err) => {
            console.log(err);
        })
    }
    //For store Agile projects for offline End
    //For Getting offline Project List Start
    getAgileProjects() {
        db.getAgileProjects().then((data) => {
            console.warn("AgileProjectsList" + JSON.stringify(data))
            this.setState({
                data2: data,
            });
        }).catch((err) => {
        })
    }
    //For Getting offline Project List End

    //to refresh the data
    onRefresh() {
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
            } else {
                //to get the lsit of list of employees
                this.UserManageEmployees()
                // this.getMessages();
            }
        });

    }

    //get project list dropdown data


    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects();
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',

                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            // alert(JSON.stringify(responseJson.data))
                            if (responseJson.status == 'True') {
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource1: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });
                                console.log("Testing" + JSON.stringify(responseJson.data))
                                const data2 = [];
                                this.addAgileProjects(responseJson.data) //Project list store in offline
                                responseJson.data.map(x => {
                                    data2.push({ label: x.value, value: x.value })
                                })
                                this.setState({
                                    data2: data2,
                                })
                                console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }
    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;

                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        this.setState({
                            squadName: squadName
                        });
                        AsyncStorage.setItem('cropcode', squadName);
                        this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
                        //for offline project switching end
                    } else {

                        fetch(API + 'squad_login.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username: empId,
                                corp: squadName,
                                projectId: projectId

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                    AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                    AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                    AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                    AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                                    AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    this.setState({

                                        squadName: tokenDetails.data.corp,

                                    });
                                    this.UserManageEmployees();
                                    //  alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }

    //For getManageEmployeesList from offline
    getManageEmployeesList() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            const projectName = res;
            db.getManageEmployeesList(projectName).then((data) => {
                console.warn("ManageEmployeesList" + JSON.stringify(data))
                this.setState({
                    dataSource: data,
                    isLoading: false,
                });
                this.arrayholder = data;
            }).catch((err) => {
                console.log(err);
                this.setState = {
                    isLoading: false
                }
            })
        })
    }
    //For getManageEmployeesList from offline

    //For store ManageEmployeesList from offline
    addManageEmployeesList(data, cropcode) {
        console.warn("hello" + JSON.stringify(data));
        db.addManageEmployeesList(data, cropcode).then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {
            console.log(err);
            this.setState({
                isLoading: false,
            });
        })
    }
    // componentWillReceiveProps(nextProps) {
    //   //to get the lsit of list of employees
    //   this.UserManageEmployees();
    // }

    //to get the lsit of list of employees
    UserManageEmployees() {
        log("Info", "UserManageEmployees:getEmployeeList() method is used to get employee list");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("empId", (err, res) => {
                const empId = res;
                AsyncStorage.getItem("projectId", (err, res) => {
                    const projectId = res;


                    AsyncStorage.getItem("emp_role", (err, res) => {
                        const emp_role = res;
                        //Checking the Internet Connection
                        NetInfo.fetch().then(state => {
                            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {

                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {

                                fetch(API + 'agile_squads.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            crop: cropcode,
                                            // projectId: projectId,
                                            userType: emp_role,
                                            // action: "pending",
                                            // userType: emp_role,
                                            empId: empId
                                        })
                                    })
                                    .then((response) => response.json())

                                    // console.warn(responseJson.data)


                                    .then((responseJson) => {
                                        // alert(JSON.stringify(responseJson))
                                        // console.warn("Employees" + JSON.stringify(responseJson));
                                        this.addManageEmployeesList(responseJson.data, cropcode) //Store Manage Employee List in Offline 
                                        this.setState({
                                            isLoading: false,
                                            dataSource: responseJson.data,
                                            isFetching: false
                                        }, function () {
                                        });
                                        this.arrayholder = responseJson.data;

                                    })
                                    .catch((error) => {
                                        check.Maintenance();
                                        console.error(error);
                                        log("Error", "error in getting employee list at user side");
                                    });

                            }
                        });

                    });
                });

            });

        });
    }


    //Seperate the List date
    FlatListItemSeparator = () => {
        return (
            <View
                style={{
                    //  height: .5,
                    width: "100%",
                    backgroundColor: "#000",
                }}
            />
        );
    }
    //For Empty list
    _listEmptyComponent = () => {
        return (
            <View>
                <Text></Text>

            </View>
        )
    }

    //to filter the search data in search area 
    SearchFilterFunction(text) {
        log("Info", "UserManageEmployees:SearchFilterFunction(text) method is used for search functionality")
        const newData = this.arrayholder.filter(function (item) {

            const name = item.name.toUpperCase()
            const name1 = text.toUpperCase()
            const empStatus = item.empStatus.toUpperCase()
            const empStatus1 = text.toUpperCase()
            //const designation = item.designation.toUpperCase()
            const designation1 = text.toUpperCase()
            const email = item.email.toUpperCase()
            const email1 = text.toUpperCase()
            const mobileNumber = item.mobileNumber.toUpperCase()
            const mobileNumber1 = text.toUpperCase()

            return name.indexOf(name1) > -1 ||
                //  date.indexOf(date1) > -1 || 
                empStatus.indexOf(empStatus1) > -1 ||
                //designation.indexOf(designation1) > -1 ||
                email.indexOf(email1) > -1 ||
                mobileNumber.indexOf(mobileNumber1) > -1
        })
        this.setState({
            dataSource: newData,
            text: text
        })
    }






    render() {
        let button;
        if (this.state.emp_role === "Emp") {
            button = null;
        } else {
            button =
                <TouchableOpacity style={{ marginTop: 12 }}
                    onPress={(item) => this.props.navigation.navigate("UserManageEmployeesTasks", {
                        empId: item.id,
                        name: item.name,
                        mobile: item.mobileNumber,
                        email: item.email,
                        designation: item.designation,
                        userName: item.userName,
                        team: item.team,
                        empStatus: item.empStatus,
                        workingStatus: item.workingStatus,
                        role: item.role
                    })}>
                    {/* <Icon name="chevron-right" style={{ color: '#808080', paddingRight: 5 }} size={15} /> */}
                </TouchableOpacity>
        }

        let button5;
        // if (this.state.emp_role === "Emp") {
        //     // button = null;
        //     button5 =

        //         //  <View style={{ height: hp('10%') }}></View>
        //         <TouchableOpacity onPress={() => this.props.navigation.navigate("AddUser")} style={styles.bottomView}>

        //             <View style={styles.bottomView} >
        //                 <Text style={styles.textStyle}> Add Squad Member</Text>
        //             </View>
        //         </TouchableOpacity>
        // } else {
        //     button5 =

        //         //  <View style={{ height: hp('10%') }}></View>
        //         <TouchableOpacity onPress={() => this.props.navigation.navigate("AddUser")} style={styles.bottomView}>

        //             <View style={styles.bottomView} >
        //                 <Text style={styles.textStyle}> Add Squad Member</Text>
        //             </View>
        //         </TouchableOpacity>
        // }


        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }

        return (
            <Container style={{ height: Dimensions.get('window').height }}>
                {/* <NavigationEvents
          onDidFocus={() => this.onRefresh()}
        /> */}

                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Icon name="bars" size={25} style={{ color: 'white', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </View>

                    <View style={{ flexDirection: 'row', marginRight: 55, marginTop: 20 }}>

                        <Text style={{ flexDirection: 'row', marginRight: 55, marginLeft: 15, color: 'white' }}>Manage Employee</Text>
                    </View>
                    {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
                    {/* <View style={{backgroundColor:'white',width:300,borderRadius:20,height:50,marginTop:5}}> */}




                </Header>
                <Item >
                    {/* <NavigationEvents
            onDidFocus={() => this.onRefresh()}
          /> */}
                    <Input placeholder="Search"
                        onChangeText={(text) => this.SearchFilterFunction(text)} />
                    <Icon style={{ marginRight: 10, color: 'black' }} size={25} name="search" />
                </Item>
                <View style={{ height: '78%' }}>

                    <FlatList
                        extraData={this.state}
                        keyExtractor={this._keyExtractor}
                        renderItem={this._renderItem}
                        style={{ flex: 1, }}
                        data={this.state.dataSource}
                        onRefresh={() => this.onRefresh()}
                        refreshing={this.state.isFetching}
                        ItemSeparatorComponent={this.FlatListItemSeparator}
                        renderItem={({ item, index }) =>
                            <View style={styles.container2} >
                                <ListItem
                                    navigation={this.props.navigation}
                                    emp_role={this.state.emp_role}
                                    item={item}
                                    deleteAction={() => this.deleteAction(item, index)}//delete action for employee
                                    activeAction={() => this.activeAction(item, index)}//delete action for employee

                                />
                            </View>
                        }
                        keyExtractor={item => item.id}
                        ListEmptyComponent={this._listEmptyComponent}
                    />

                    {/* <SwipeListView
            data={this.state.dataSource}
            onRefresh={() => this.onRefresh()}
            refreshing={this.state.isFetching}
            renderItem={(data) => (

              <View style={styles.container2} >
                <ListItem navigation={this.props.navigation}
                  data={data}
                  deleteAction={() => this.deleteAction(data, index)}//delete action for employee

                  emp_role={this.state.emp_role}

                />
              </View>

            )}

            renderHiddenItem={(data, rowMap) => (

              <View style={styles.rowBack}>

                <Text>{data.item.empStatus}</Text>
                <Text>{data.item.empStatus}</Text>
              </View>

            )}

            leftOpenValue={100}
            rightOpenValue={-100}

          /> */}
                    <View style={{ marginBottom: 5, }} />
                </View>

                {/* <View style={{ height: hp('10%') }}></View> */}
                {button5}

                {/* <View style={{ height: hp('10%') }}></View>
        <TouchableOpacity onPress={() => this.props.navigation.navigate("AddUser")} style={styles.bottomView}>

          <View style={styles.bottomView} >
            <Text style={styles.textStyle}>  {ADDEMPLOYEE}</Text>
          </View>
        </TouchableOpacity> */}

            </Container>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    container: {
        flex: 1,
        paddingTop: 15,
        backgroundColor: 'white',

        paddingRight: 20,
    },
    buttonContainer: {
        width: wp('95%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        //backgroundColor:'#fadbd8',
        marginLeft: 4,
    },
    signupButton: {


    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',

    },
    signUpText0: {
        fontSize: 15,

        paddingLeft: 20,
    },
    signUpText1: {
        fontSize: 16,

        paddingLeft: 10,
        fontWeight: 'bold'
    },

    signUpText00: {
        fontSize: 15,

        paddingLeft: 20,
    },
    signUpText11: {
        fontSize: 12,
        paddingTop: 10,

        color: 'black',
        paddingLeft: 10,
    },
    signUpText11email: {
        fontSize: 12,
        paddingTop: 10,

        color: 'black',
        paddingLeft: 10,
    },
    signUpText11mobile: {
        fontSize: 12,
        paddingTop: 10,
        //fontStyle: 'italic',
        color: 'black',
        paddingLeft: 10,
    },
    signUpText12: {
        fontSize: 15,
        paddingTop: 10,
        paddingBottom: 10,
        color: 'black',
        paddingLeft: 15,
    },

    signUpText000: {
        fontSize: 12,

        paddingBottom: 10,
        paddingLeft: 20,
    },
    signUpText111: {
        fontSize: 12,
        paddingBottom: 10,

        color: 'black',

        paddingLeft: -20,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 1,

        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        // backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),
        borderTopLeftRadius: 10,
        borderBottomLeftRadius: 10,

    },
    signUpText2: {
        fontSize: 15,
        paddingRight: 10,

        paddingLeft: 23,
        color: 'black',

        justifyContent: 'center',

    },
    signUpText02: {
        fontSize: 15,
        paddingRight: 10,

        paddingLeft: 23,
        color: 'red',
        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText022: {
        fontSize: 15,

        paddingLeft: 23,
        color: 'green',
        paddingBottom: 10,

        justifyContent: 'center',

    },
    rowBack: {
        alignItems: 'center',
        backgroundColor: '#81def0',
        flex: 1,
        flexDirection: 'row',
        justifyContent: 'space-between',
        paddingLeft: 10,
    },
    rowFront: {
        alignItems: 'center',
        backgroundColor: '#81def0',
        flex: 1,
        flexDirection: 'row',
        justifyContent: 'space-between',
        paddingRight: 10,
    },
    signUpText002: {
        fontSize: 12,

        paddingLeft: 23,

        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText0002: {
        fontSize: 13,
        paddingRight: 45,

        paddingLeft: 23,

        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText3: {

        paddingBottom: 10,
        paddingLeft: 23,
        fontSize: 15,

        paddingRight: 13,

        alignItems: 'center',
    },
    signUpText4: {
        paddingBottom: 10,
        paddingLeft: 20,

        fontSize: 15,
        alignItems: 'center',
    },


    signUpText33: {

        paddingBottom: 10,
        paddingLeft: 23,
        fontSize: 12,

        paddingRight: 35,

        alignItems: 'center',
    },
    signUpText44: {
        paddingBottom: 10,
        paddingLeft: 20,

        paddingTop: -10,

        fontSize: 12,
        alignItems: 'center',
    },

    signup: {

        color: "#FFF",
    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        justifyContent: 'space-between',
        flexDirection: 'row',
        position: 'relative',


    },
    bottomView: {
        flexDirection: 'row',
        justifyContent: 'center',
        position: 'absolute',
        // height: FOOTER_MAX_HEIGHT,
        bottom: 0,
        left: 0,
        right: 0,
        backgroundColor: 'black',
        alignItems: 'center'
    },
    textStyle: {

        color: '#fff',
        paddingLeft: 5,
        paddingRight: 5,
        backgroundColor: '#00A2C1',
        fontSize: 22,
        marginLeft: 5,
        borderRadius: 5

    },
    signUpText: {
        fontSize: 20,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
    empstatusText: {
        fontSize: 12,
        paddingLeft: 23,
        paddingBottom: 10,
        justifyContent: 'center',
        // fontStyle: 'italic'

    },
    designationText: {
        fontSize: 12,
        paddingLeft: 23,
        paddingBottom: 10,
        //   fontWeight:'bold',
        justifyContent: 'center',

    },
});