/*
FileName:AdminReportsUser.js
Version:1.0.0
Purpose:Working Hours showing in table formate
Devloper:Mahesh,Santhosh
*/
import React, { Component } from 'react';
import {
    Platform, StyleSheet, TextPropTypes, Picker, Text, Button, View, Image, StatusBar, Dimensions, TextInput, Alert,
    KeyboardAvoidingView,
    TouchableWithoutFeedback,
    FlatList,
    Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
    DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';
import moment from "moment";
import DateRangePicker from "react-native-daterange-picker";
import { DataTable } from 'react-native-paper';

class ListItem extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            // roledata: '',
        }

    }


    render() {
        const { item } = this.props;
        // alert("Setting")
        AsyncStorage.getItem("emp_role", (err, res) => {
            this.setState({
                roledata: res
            })

        });


        return (
            <View style={styles.container}>

                <View style={{ flexDirection: 'row' }}>
                    <View style={{ flexDirection: 'row', width: 140, borderWidth: 1, borderColor: 'black' }}>
                        <Text style={{}} >{item.story_title}</Text>
                    </View>

                    <View style={{ flexDirection: 'row', }}>
                        <View style={{ flexDirection: 'row', borderWidth: 1, borderColor: 'black' }}>
                            <Text style={{ width: 80 }} >  {item.working_hours}  </Text>
                        </View>


                    </View>
                </View>

            </View>

        )
    }
}

export default class AdminReportsUser extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: false,
            isVisibleB: false,
            sprintName: 'Select User',
            epicName: 'Select Epic',
            resource: [],
            resource1: [],
            dataSource: [],
            userReports: [],
            projectCount: [],
            // employee:[],
            // startDate: null,
            // endDate: null,
            displayedDate: moment(),
            startDate: moment().set("date", -15),
            endDate: moment().set("date", 15),
            selectedDays: [],
            selectedWeeks: [],
            emp_id: this.props.navigation.state.params.emp_id,
            name: this.props.navigation.state.params.name,
            projects_involved: this.props.navigation.state.params.projects_involved,
            startDate:this.props.navigation.state.params.startDate,
            endDate:this.props.navigation.state.params.endDate,
            select: ''
        }

        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
        // alert(this.state.startDate)

    }

    setDates = (dates) => {
        this.setState({
            ...dates,
        });
    };




    componentDidMount() {

        this.Reports();
    }


    Reports() {
        const { assignedto, sprintName, startDate, endDate } = this.state;
        // alert("Test")
        // alert("value:"+assignedto+"label:"+sprintName)
        // alert("startDate :"+moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]')+"endDate :"+moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'))

        const data = {
            "selectedOption":
            {
                "value": this.props.navigation.state.params.emp_id,
                "label": this.props.navigation.state.params.name
            }
        }
        const filter =[{
            startDate:  moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
            endDate:  moment(this.state.endDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
            "key": "selection"
        }]

        NetInfo.fetch().then(state => {
            if (state.type == "none") {
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            } else {

                fetch(ReportsAPI + `getDataV1`, {
                    method: 'POST',
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                    },

                    body: JSON.stringify({
                        data,
                        filter
                    })

                }).then((response) => response.json())
                    .then((responseJson) => {
                        // alert("data" + JSON.stringify(responseJson))

                        // var sprintList = [];
                        // responseJson.map((sprints) => {
                        //   return (
                        //     sprintList.push({
                        //       'id': sprints.emp_id, 'name': sprints.fullname
                        //     })
                        //   );
                        // })

                        // var employee = [];
                        // responseJson.map((x) => {
                        //     return (x.name !== "admin@novisync.com" ? employee.push(x) : null);
                        // })

                        this.setState({
                            userReports: responseJson.projectData,
                            projectCount: responseJson.projectCount,
                        },
                            function () {

                            }
                        );
                        // alert("data "+JSON.stringify(this.state.dataSource)+"test")

                    }).catch((error) => {
                        check.Maintenance();
                        console.error(error);
                        log("Error", "Error in getting profile data");

                    });
            }


        });
    }



    render() {
        const { assignedto, sprintName, startDate, endDate, displayedDate } = this.state;


  


        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }

        return (
            // <KeyboardAvoidingView
            //     style={{ flex: 1 }}
            //     behavior={Platform.OS === "ios" ? "padding" : "height"}
            // >
            <Container>

                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Text size={25} style={{color:'black',paddingTop:5}} onPress={() => this.props.navigation.goBack(null)}>Back</Text>
                        {/* <Icon name="md-menu" size={25} style={{ color: 'white', }}  onPress={() =>
              this.props.navigation.goBack(null)} /> */}
                    </View>

                    <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                        <Text style={{ width: 300, borderRadius: 20, height: 45, marginTop: 20, flexDirection: 'row', color: 'white' }}>AdminReports</Text>



                    </View>

                </Header>
                <Content>


                    <View style={{ marginTop: 10 }}>
                        <Text style={{ fontSize: 14, fontWeight: 'bold', marginLeft: 5 }} > EMPLOYEE_NAME: {this.state.name}</Text>
                        <Text style={{ fontSize: 14, fontWeight: 'bold', marginLeft: 30 }} > PROJECTS_INVOLVED}: {this.props.navigation.state.params.projects_involved} </Text>
                        <Text style={{ fontSize: 14, fontWeight: 'bold', marginLeft: 30 }} > DATE: {moment(this.state.startDate).format('YYYY-MM-DD[]')}-{moment(this.state.endDate).format('YYYY-MM-DD[]')} </Text>

                    </View>


                    <ScrollView horizontal style={{ height: '40%', marginTop: 10 }}>
                        <View>

                            <DataTable>
                                <DataTable.Header style={{ backgroundColor: '#333f50', color: "white" }}>
                                    <DataTable.Title style={{ width: 200 }}><Text style={{ color: "white" }}>PROJECT_NAME</Text></DataTable.Title>
                                    <DataTable.Title style={{ width: 200 }}><Text style={{ color: "white" }}>SPRINT_NAME</Text></DataTable.Title>
                                    <DataTable.Title style={{ width: 200 }}><Text style={{ color: "white" }}>ASSIGNED_STORY_POINTS</Text></DataTable.Title>
                                    <DataTable.Title style={{ width: 100 }}><Text style={{ color: "white" }}>PENDING</Text></DataTable.Title>
                                    <DataTable.Title style={{ width: 100 }}><Text style={{ color: "white" }}>COMPLETED</Text></DataTable.Title>

                                </DataTable.Header>
                            </DataTable>
                            {this.state.userReports.length !== 0 ? this.state.userReports.map((item, index) => {
                                return (
                                    <DataTable>
                                        <DataTable.Row style={{ marginLeft: -10 }} key={index}>

                                            <DataTable.Cell style={{ backgroundColor: '#eaedf3', width: 200 }}>{item.result.project_name}</DataTable.Cell>

                                            <DataTable.Cell style={{ paddingLeft: 20, width: 200 }}>{item.result.sprint_desc}</DataTable.Cell>
                                            {item.result.estimated !== null ? <DataTable.Cell style={{ width: 200 }}>{item.result.estimated}</DataTable.Cell> : <DataTable.Cell style={{ width: 200 }}>0</DataTable.Cell>}
                                            {item.result.pending !== null ? <DataTable.Cell style={{ width: 100 }}>{item.result.pending}</DataTable.Cell> : <DataTable.Cell style={{ width: 100 }}>0</DataTable.Cell>}
                                            {item.result.completed !== null ? <DataTable.Cell style={{ width: 100 }}>{item.result.completed}</DataTable.Cell> : <DataTable.Cell style={{ width: 100 }}>0</DataTable.Cell>}

                                        </DataTable.Row>


                                    </DataTable>


                                )
                            }) : null}

                        </View>

                    </ScrollView>

                </Content>

            </Container>
            // </KeyboardAvoidingView >
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        width: '90%',
        paddingLeft: hp('2%'),
    },
    footer: {
        position: 'absolute',
        flex: 0.1,
        left: 0,
        right: 0,
        bottom: -10,
        backgroundColor: 'green',
        flexDirection: 'row',
        height: 80,
        alignItems: 'center',
    },
    bottomButtons: {
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    footerText: {
        color: 'white',
        fontWeight: 'bold',
        alignItems: 'center',
        fontSize: 18,
    },
    buttonContainer: {
        width: wp('90%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,



    },
    signupButton: {

        backgroundColor: '#ffffff',
    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',
        paddingTop: 40
    },
    signUpText0: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

    },
    signUpText1: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

        paddingLeft: 10,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 2,
        height: '50%',
        paddingTop: 20,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),

    },
    signUpText2: {
        fontSize: 13,
        marginLeft: 20,

        color: 'green',
        paddingTop: 10,
    },
    signUpText3: {

        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,

        alignItems: 'center',
    },
    signUpText4: {
        fontSize: 13,
        paddingTop: 10,


        alignItems: 'center',
    },
    signup: {
        color: "#FFF",

    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 10,


    },
    opensave: {
        // flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },

    top: {
        // flex: 1,
        ...Platform.select({
            ios: {
                flex: 1, marginTop: 10, marginBottom: 10,
            },
            android: {
                flex: 1, marginTop: 10, marginBottom: 10, height: 400
            },
        }),
    },
    signUpText: {
        fontSize: 13,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
});