import React, { Component } from 'react';
import { Platform, StyleSheet, FlatList, TextPropTypes, TouchableOpacity, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert, ScrollView } from 'react-native';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Subtitle, Item, Input, FooterTab } from 'native-base';
import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import TimePicker from "react-native-super-timepicker";
import ModalSelector from 'react-native-modal-selector';

class ListItem extends Component {

  constructor(props) {
    super(props);
    this.state = {
      // isLoading: true,
      dataSource: [],

    }

  }


  render() {



    const { item } = this.props;



    return (

      <View style={styles.container}>
        <View style={styles.signup}>
          <View style={[styles.buttonContainer, styles.signupButton]} >
            <View style={styles.box}>
              <View style={{ flexDirection: 'row' }}>
                <Text style={styles.signUpText1} >{item.name}</Text>
              </View>


            </View>
            <View style={{ flexDirection: 'row', }}>
              <View style={{ flexDirection: 'row', width: wp('75%') }}>
                <Text style={styles.signUpText11}>Sno :{item.ts_id} </Text>
                <Text style={styles.signUpText11}>Start Time :{item.start_time} </Text>
                <Text style={styles.signUpText11}>End Time :{item.end_time} </Text>

              </View>
              <TouchableOpacity style={{ backgroundColor: '#E3E2DF', marginLeft: 30, borderRadius: 10, width: wp('10%') }} onPress={() => this.props.ModifyStory()}>

                <Text style={{ fontSize: 12, paddingTop: 5, color: 'black', paddingLeft: 10, }}>Edit</Text>
              </TouchableOpacity>
            </View>

            <View style={{ flexDirection: 'row', }}>
              <Text style={styles.signUpText11}>Time Zone:{item.time_zone} </Text>

            </View>

          </View>



        </View>

        <View
          style={{
            marginTop: 15,
            borderBottomColor: '#C0C0C0',
            borderBottomWidth: 1,
          }}
        />
      </View>
    )
  }
}

export default class Settings extends Component {
  constructor(props) {
    super(props);
    // props.navigation.setParams({
    //     onTabFocus: this.handleTabFocus
    // });
    let button;
    this.state = {
      isLoading: true,
      dataSource: [],
      dataSource1: [],
      isFetching: false,
      result: '',
      emp_role: '',
      squadName: '',
      start_time: "start time",
      end_time: "end time",
      time: '',
      time1: '',
      textInputValue: '',
      hour1: '',
      minute1: '',
      hour2: '',
      minute2: '',



    }
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
    this.arrayholder = [];
    // this.button = button;
    this.getShifts();

  }

  componentDidMount() {
    this.getShifts()
  }

  //to refresh the data
  onRefresh() {
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        // this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
      } else {
        //to get the lsit of list of employees
        this.getShifts()
        // this.getMessages();
      }
    });

  }

  //getting the Employees list for addind maintask
  getShifts() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");

    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;
      // alert(projectId)

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        // alert(cropcode)
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'get_user_shifts.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({

                  action: "get_shifts",


                })
              })
              .then((response) => response.json())

              .then((responseJson) => {
                // alert(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {
                  console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                  // alert(JSON.stringify(responseJson))
                  this.setState({
                    isLoading: false,
                    dataSource: responseJson.data,
                    isFetching: false
                  }, function () {
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  onCancel() {
    this.TimePicker1.close();
    this.TimePicker2.close();
  }

  onConfirm(hour, minute) {

    this.setState({ time: `${hour}:${minute}` });
    this.TimePicker1.close();
    // alert(`${hour}:${minute}`)
  }
  onConfirm1(hour1, minute1) {

    this.setState({ time1: `${hour1}:${minute1}` });
    this.TimePicker2.close();
    // alert("end time"+`${hour1}:${minute1}`)

  }

  //Validatios
  isValid() {
    const { hour1, minute1, hour2, minute2, textInputValue } = this.state;
    let valid = false;

    // if (hour1.length === 0) {
    //   log("Warn", "Select Starting Time Hours");
    //   alert("Select Starting Time Hours");
    // }
    // else if (minute1.length === 0) {
    //   log("Warn", "Select Starting Time Minute");
    //   alert("Select Starting Time Minute");
    // }
    // else if (hour2.length === 0) {
    //   log("Warn", "Select Ending Time Hours");
    //   alert("Select Ending Time Hours");
    // }
    // else if (minute2.length === 0) {
    //   log("Warn", "Select Ending Time Minute");
    //   alert("Select Ending Time Minute");
    // }
    if (textInputValue.length === 0) {
      log("Warn", "Select  Time Zone");
      alert("Select Time Zone");
    }

    else {
      valid = true;
    }
    return valid;
  }

  //Add time shift 
  addTimeShift() {
    if (this.isValid()) {
      log("Info", " addTimeShift(cropcode) is used for getting the Employees list for addind maintask");
      const { hour, minute, hour1, minute1, textInputValue } = this.state;
      // const start_time=hour+minute;
      const { time } = `${hour}:${minute}`;
      const { time1 } = `${hour1}:${minute1}`;
      // alert(this.state.time);
      // alert(textInputValue)
      // alert("Time1"+this.state.time1);
      // const { ideaid } = this.state;
      // alert("test")
      // AsyncStorage.getItem("time", (err, res) => {
      //   const time = res;
      //   alert("Start Time"+this.state.time)
      //   AsyncStorage.getItem("time1", (err, res) => {
      //     const time1 = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getOfflineSprints(); //Getting Offline Sprint List
        }

        else {
          fetch(API + 'get_user_shifts.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                // crop: cropcode,
                action: 'add_shift',
                // projectId: projectId,
                start_time: this.state.time,
                end_time: this.state.time1,
                time_zone: textInputValue
              })
            })

            .then((response) => response.json())

            .then((responseJson) => {

              if (responseJson.status === 'True') {
                this.getShifts();
                alert(JSON.stringify(responseJson.message))
                // console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                // alert(JSON.stringify(responseJson))
                var sprintDetails = [];

                responseJson.data.map((sprints) => {
                  const [year, month, date] = sprints.startDate.split('-');
                  const [year1, month1, date1] = sprints.targetDate.split('-');
                  return (
                    sprintDetails.push({ 'key': sprints.moduleId, 'epicId': sprints.ideaId, 'label': sprints.moduleDesc })
                  );
                })

                this.setState({
                  resource: sprintDetails
                });
                this.addOfflineSprints(sprintDetails, cropcode)//Store Sprint List in Offline
              }
            })
            .catch((error) => {
              // alert("test")
              console.error(error);
              log("Error", "requested projects error");
            });
        }
      });
    }
    //   });
    // });

  }

  //Navigate to Project Modify Screen
  ModifyStory(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "ModifyStory() method is used to move Add Module to Add ModifyUserStory screen");
    this.props.navigation.navigate('SettingsModify', { ts_id: item.ts_id, start_time: item.start_time, end_time: item.end_time, time_zone: item.time_zone, });

  }
  _onValueChange1 = (hour1, minute2) => {
    console.log("Selected time:", hour1, ':', minute1);
  };
  _onValueChange2 = (hour1, minute2) => {
    console.log("Selected time:", hour2, ':', minute2);
  };


  render() {

    let index = 0;
    const data = [
      { key: index++, label: 'IST' },
      { key: index++, label: 'EST' },
      { key: index++, label: 'CST' },
      { key: index++, label: 'PST' },
      { key: index++, label: 'GMT' },
      { key: index++, label: 'MST' },
      { key: index++, label: 'ARAB' },
    ];


    return (
      <Container style={{ height: Dimensions.get('window').height }}>
        {/* <NavigationEvents
    onDidFocus={() => this.onRefresh()}
  /> */}

        <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <View style={{ marginTop: 20 }}>
            <Icon name="bars" size={25} style={{ color: 'white', }} onPress={() =>
              this.props.navigation.toggleDrawer()} />
          </View>

          <View style={{ flexDirection: 'row', marginRight: 55, marginTop: 20 }}>

            {/* <Text style={{ flexDirection: 'row', marginRight: 55, marginLeft: 15, color: 'white' }}>Settings</Text> */}
          </View>
          {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
          {/* <View style={{backgroundColor:'white',width:300,borderRadius:20,height:50,marginTop:5}}> */}




        </Header>
        {/* <Item >
          <NavigationEvents
      onDidFocus={() => this.onRefresh()}
    />
          <Input placeholder="Search"
            onChangeText={(text) => this.SearchFilterFunction(text)} />
          <Icon style={{ marginRight: 10, color: 'black' }} size={25} name="search" />
        </Item> */}

        <View >
          <View style={{ flexDirection: 'row' }}>
            <TouchableOpacity
              onPress={() => this.TimePicker1.open()}
              style={{ width: '45%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10, height: 40 }}
            >
              <Text style={{ padding: 10 }}>Start Time : {this.state.time}</Text>
            </TouchableOpacity>





            {/* Time 1 */}
            <TimePicker
              ref={(ref) => {
                this.TimePicker1 = ref;
              }}
              onCancel={() => this.onCancel()}
              onConfirm={(hour, minute) => this.onConfirm(hour, minute)}
            // onValueChange={this._onValueChange1}

            />

            {/* <Text style={styles.text}>start date : {this.state.time}</Text> */}
            <TouchableOpacity
              onPress={() => this.TimePicker2.open()}
              style={{ width: '45%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10, height: 40 }}
            >
              <Text style={{ padding: 10 }}>End Time : {this.state.time1}</Text>
            </TouchableOpacity>


            {/* Time 2 */}
            <TimePicker
              ref={(ref) => {
                this.TimePicker2 = ref;
              }}
              onCancel={() => this.onCancel()}
              onConfirm={(hour1, minute1) => this.onConfirm1(hour1, minute1)}
            // onValueChange={this._onValueChange2}

            />

            {/* <Text style={styles.text}>end Date : {this.state.time1}</Text> */}

          </View>
          <Text style={{ margin: 10 }}>Select Time Zone</Text>
          <View style={{ flexDirection: 'row' }}>


            <ModalSelector
              style={{ width: '70%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10 }}
              data={data}
              initValue="Select something yummy!"
              // supportedOrientations={['landscape']}
              accessible={true}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ textInputValue: option.label }) }}>
              <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                {/* <Text style={{ marginTop: 15, color: 'black', width: 80 }}>PROJECT : </Text> */}

                <Text style={{ marginTop: 12, color: 'black', width: 120, marginLeft: 10 }}>{this.state.textInputValue}</Text>

                <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                />
              </View>





            </ModalSelector>

            <TouchableOpacity style={{ height: 40, width: '16%', backgroundColor: 'green', textAlign: 'center', marginTop: 15 }} onPress={this.addTimeShift.bind(this)} >
              <Text style={{ color: 'white', padding: 10 }}>Submit</Text>
            </TouchableOpacity>
          </View>
        </View>
        {/* </View> */}
        <View style={{ height: '70%' }}>

          <FlatList
            extraData={this.state}
            keyExtractor={this._keyExtractor}
            renderItem={this._renderItem}
            style={{ flex: 1, }}
            data={this.state.dataSource}
            onRefresh={() => this.onRefresh()}
            refreshing={this.state.isFetching}
            ItemSeparatorComponent={this.FlatListItemSeparator}
            renderItem={({ item, index }) =>
              <View style={styles.container2} >
                <ListItem
                  navigation={this.props.navigation}
                  emp_role={this.state.emp_role}
                  ModifyStory={() => this.ModifyStory(item, index)}//For Modify Sprint 
                  item={item}
                  deleteAction={() => this.deleteAction(item, index)}//delete action for employee
                />
              </View>
            }
            keyExtractor={item => item.id}
            ListEmptyComponent={this._listEmptyComponent}
          />


          <View style={{ marginBottom: 5, }} />
        </View>


      </Container>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  container: {
    flex: 1,
    paddingTop: 15,
    backgroundColor: 'white',

    paddingRight: 20,
  },
  buttonContainer: {
    width: wp('95%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    //backgroundColor:'#fadbd8',
    marginLeft: 4,
  },
  signupButton: {

    paddingRight: 20,
  },
  buttonContainer: {
    width: wp('95%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    //backgroundColor:'#fadbd8',
    marginLeft: 4,
  },
  signupButton: {

  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',

  },
  signUpText0: {
    fontSize: 15,

    paddingLeft: 20,
  },
  signUpText1: {
    fontSize: 16,

    paddingLeft: 10,
    fontWeight: 'bold'
  },

  signUpText00: {
    fontSize: 15,

    paddingLeft: 20,
  },
  signUpText11: {
    fontSize: 12,
    paddingTop: 10,

    color: 'black',
    paddingLeft: 10,
  },
  signUpText11email: {
    fontSize: 12,
    paddingTop: 10,

    color: 'black',
    paddingLeft: 10,
  },
  signUpText11mobile: {
    fontSize: 12,
    paddingTop: 10,
    //fontStyle: 'italic',
    color: 'black',
    paddingLeft: 10,
  },
  signUpText12: {
    fontSize: 15,
    paddingTop: 10,
    paddingBottom: 10,
    color: 'black',
    paddingLeft: 15,
  },

  signUpText000: {
    fontSize: 12,

    paddingBottom: 10,
    paddingLeft: 20,
  },
  signUpText111: {
    fontSize: 12,
    paddingBottom: 10,

    color: 'black',

    paddingLeft: -20,
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 1,

    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    // backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),
    borderTopLeftRadius: 10,
    borderBottomLeftRadius: 10,

  },
  signUpText2: {
    fontSize: 15,
    paddingRight: 10,

    paddingLeft: 23,
    color: 'black',

    justifyContent: 'center',

  },
  signUpText02: {
    fontSize: 15,
    paddingRight: 10,

    paddingLeft: 23,
    color: 'red',
    paddingBottom: 10,

    justifyContent: 'center',

  },
  signUpText022: {
    fontSize: 15,

    paddingLeft: 23,
    color: 'green',
    paddingBottom: 10,

    justifyContent: 'center',

  },

  signUpText002: {
    fontSize: 12,

    paddingLeft: 23,

    paddingBottom: 10,

    justifyContent: 'center',

  },
  signUpText0002: {
    fontSize: 13,
    paddingRight: 45,

    paddingLeft: 23,

    paddingBottom: 10,

    justifyContent: 'center',

  },





  signup: {

    color: "#FFF",
  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    justifyContent: 'space-between',
    flexDirection: 'row',
    position: 'relative',


  },
  bottomView: {
    flexDirection: 'row',
    justifyContent: 'center',
    position: 'absolute',
    // height: FOOTER_MAX_HEIGHT,
    bottom: 0,
    left: 0,
    right: 0,
    backgroundColor: 'black',
    alignItems: 'center'
  },
  textStyle: {

    color: '#fff',
    paddingLeft: 5,
    paddingRight: 5,
    backgroundColor: '#00A2C1',
    fontSize: 22,
    marginLeft: 5,
    borderRadius: 5

  },
  signUpText: {
    fontSize: 20,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
  empstatusText: {
    fontSize: 12,
    paddingLeft: 23,
    paddingBottom: 10,
    justifyContent: 'center',
    // fontStyle: 'italic'

  },
  designationText: {
    fontSize: 12,
    paddingLeft: 23,
    paddingBottom: 10,
    //   fontWeight:'bold',
    justifyContent: 'center',

  },
});
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'black',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
    // backgroundColor:'pink'
  },
});