/*
FileName:AddRoadblock.js
Version:1.0.0
Purpose:Modify the existing module
Devloper:Naveen, Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, ScrollView, Text, View, Dimensions, FlatList, Picker, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import SearchableDropdown from 'react-native-searchable-dropdown';
import ModalSelector from 'react-native-modal-selector';

import RNPickerSelect from 'react-native-picker-select';
// import {
//   Dropdown,
//   GroupDropdown,
//   MultiselectDropdown,
// } from 'sharingan-rn-modal-dropdown';
// import { Dropdown } from 'react-native-material-dropdown';

import Toast from 'react-native-simple-toast';
import log from '../LogFile/Log';

export default class AddRoadblock extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      open: false,
      ProjectTitle: "",
      ProjectDescription: "",
      role: '',
      userToken: '',
      empData: [],
      dependencyData: [],
      subTask: '',
      description: '',
      resource: [],
      days: '',
      time: '',
      assignedto: '',
      modifyTask: 'modify',
      dependencyid: '',
      person: '',
      prioritySelected: '',
      severitySelected: '',
      itemPressedDisabled: false,
      error1: '', error2: '', error3: '', error4: '', error5: '',
      moduleId: this.props.navigation.state.params.moduleId,

      // action: this.props.navigation.state.params.action,//getting action
      //subTask: this.props.navigation.state.params.subTask,//idea id
      subTaskId: this.props.navigation.state.params.subTaskId,
      roadblockId: this.props.navigation.state.params.roadblockId,
      tasktitle: this.props.navigation.state.params.subTaskName,
      roadBlockDescription: this.props.navigation.state.params.description,
      assignedName: 'Select Squad Name',
    };

  }
  //open Modal
  modalDidOpen = () => console.log("Modal did open.");
  //close Modal
  modalDidClose = () => {
    this.props.navigation.goBack();

    this.setState({ open: false }); this.setState({ open: false });
    console.log("Modal did close.");

  };

  //Dialog actions start
  moveUp = () => this.setState({ offset: -100 });

  resetPosition = () => {
    this.setState({ offset: 0 });
    this.props.navigation.goBack();
  }

  //open the dialog 
  openModal = () => {
    this.setState({ open: true })

  };
  //close Dialog
  closeModal = () => {
    this.setState({
      open: false,
      error1: '', error2: '', error3: '', error4: '', error5: '',
    });
    this.props.navigation.goBack();


  }
  //Dialog actions end
  componentDidMount() {
    log("Debug", "Add Sub Task Modal screen is loaded");
    this.empSearch();
    // this.dependencySearch();
    this.openModal();
    this.getEmployees();


  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    // console.warn("ModuleId"+ModuleId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                if (responseJson.status === 'True') {

                  var epicsList = [];
                  responseJson.data.map((epics) => {
                    return (
                      epics.workingStatus === "Active" ?
                        epicsList.push({
                          'id': epics.id, 'name': epics.name
                        }) : null
                    );
                  })

                  this.setState({
                    resource: epicsList,
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //Refresh data
  // onRefresh() {
  //   this.setState({ isFetching: true }, function () { this.add() });
  // }
  //Refresh the maintask list
  onRefresh() {
    this.setState({
      // dataSource: [],
    })
    this.add();
  }
  //Text Field Validation method
  isValid() {
    const { person, item, dependency, subTask, description, days, time, taskDescription } = this.state;
    let valid = false;
    // alert(taskDescription)

    // if (subTask.length === 0) {
    //   log("Warn", "subTask should not be empty");
    //   this.setState({ error1: 'Enter sub Task ' });
    // }
    // else if (description.length === 0) {
    //   log("Warn", "description should not be empty");
    //   this.setState({ error2: 'Enter Description ' });
    // }
    if (taskDescription.length === 0) {
      log("Warn", "taskDescriptionshould not be empty");
      this.setState({ error3: 'Enter taskDescription' });
    }
    // else if (time.length === 0) {
    //   log("Warn", "time should not be empty");
    //   // ToastAndroid.showWithGravity('"Enter Time', ToastAndroid.SHORT,ToastAndroid.CENTER);
    //   this.setState({ error4: 'Enter Hours' });
    // }
    // else if (person.length === 0) {
    //   log("Warn", "person should not be empty");
    //   // ToastAndroid.showWithGravity('"Enter Source', ToastAndroid.SHORT,ToastAndroid.CENTER);
    //   this.setState({ error5: 'Select Source ' });
    // }
    // else if (this.state.dependencyid == '') {
    //   log("Warn", "person should not be empty");
    //   // ToastAndroid.showWithGravity('"Enter Source', ToastAndroid.SHORT,ToastAndroid.CENTER);
    //   this.setState({ dependencyid: 'NA' });
    // }


    else {
      valid = true;
    }
    return valid;
  }//isValid method end


  isAdedSucess() {
    Toast.show("Roadblock Added", Toast.LONG);
  }

  //Add the subtask start
  addRoadblock = () => {
    log("Info", " addSubTask() is used to add sub task");
    const { item, person, tasktitle, storyPoints, taskDescription, acceptanceCriteria, assignedto, subTaskId, roadblockId, assignedBy, roadBlockDescription, taskid, subTask, description, days, time, prioritySelected, severitySelected } = this.state;
    console.warn("assignedto" + assignedto);
    console.warn("subTaskId" + subTaskId);
    console.warn("roadblockId" + roadblockId);
    console.warn("roadBlockDescription" + roadBlockDescription);
    console.warn("prioritySelected" + prioritySelected);
    console.warn("storyPoints" + storyPoints);
    console.warn("severitySelected" + severitySelected);
    console.warn("taskDescription" + taskDescription);
    console.warn("acceptanceCriteria" + acceptanceCriteria)

    // alert("assignedto"+roadblockId);


    let EstHours = Number(days * 24) + Number(time);
    // alert(Number(days) + "  " + Number(time));
    // alert(person);
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              console.log(state.type);
              log("Warn", "No internet connection");
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {
              if (this.isValid()) {
                fetch(API + 'manage_roadblocks.php', {
                  method: 'POST',
                  headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({

                    // title: subTask,
                    // description: description,
                    // days: days,
                    crop: cropcode,
                    EstimatedHours: EstHours,
                    assignedBy: empId,
                    assignedTo: assignedto,
                    // dependencyId: this.state.dependencyid,
                    action: "assignRoadblock",
                    subTaskId: subTaskId,
                    // roadblockId:this.state.roadblockId,
                    // days: this.state.days,

                    // hours: this.state.time,
                    roadblockId: roadblockId,
                    title: tasktitle,

                    roadBlockDescription: roadBlockDescription,
                    prioritySelected: prioritySelected,
                    severitySelected: severitySelected,
                    storyPoints: storyPoints,
                    description: taskDescription,
                    acceptanceCriteria: acceptanceCriteria,
                    projectId: projectId,

                    // maintaskId: this.state.taskid,
                    // moduleId: this.state.moduleId,
                    // empId: empId,
                    // crop: cropcode,

                  })
                }).then((response) => response.json())
                  .then((responseJson) => {
                    // alert(JSON.stringify(responseJson));
                    // console.log(JSON.stringify(responseJson));
                    console.log(responseJson);
                    if (responseJson.status === 'True') {
                      console.log("done")
                      this.props.navigation.goBack();
                      this.setState({ open: false })
                    }
                  }).catch((error) => {
                    console.error(error);
                    log("Error", "addSubTask  error");
                  });
                this.closeModal();
                this.isAdedSucess();

              }
            }
          });
        });
      });
    });

  };
  //Getting the Employee List for Adding subtask
  empSearch() {
    log("Info", "empSearch(cropcode) method is used to employee's data");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const crop = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          this.setState({ itemPressedDisabled: false })
          fetch(API + 'getEmployees.php', {
            method: 'POST',
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              action: "add",
              crop: crop //Async
            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              this.setState({ itemPressedDisabled: false })
              this.setState({
                empData: [...responseJson.data],
              });
            }
            )
            .catch((error) => {
              console.error(error);
              log("Error", "error in geting employees details");
            });
        }
      });
    });
  }
  //Getting Employees List end

  //Getting dependency task list start
  dependencySearch() {
    console.warn(this.props.navigation.state.params.IdeaId)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const crop = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'getSubtasks.php', {
            method: 'POST',
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              action: "setdependency",
              crop: crop, //Async
              ideaId: this.state.ideaId
            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              if (responseJson.status === 'true') {
                // alert("Your Task is Updated Successfully");
                // this.getdata();//to get the user pending my task list

                this.setState({
                  isLoading: false,
                  dependencyData: [...responseJson.data],
                  isFetching: false
                }, function () {
                });

              } else {
                Alert.alert("No depencency is available")
                // log("Info", "no pending my tasks at user side");
              }
              // if (responseJson.status === 'TRUE') {
              // this.setState({
              //   dependencyData: [...responseJson.data],
              // });
              //   }
              // else{
              //   dependencyData:[]
              // }
              // this.setState({
              //   dependencyData: [...responseJson.data],
              // });
            }
            )
            .catch((error) => {
              console.error(error);
              log("Error", "error in geting employees depencey ");
            });
        }
      });
    });
  }
  //Getting dependency task list end

  render() {


    let index = 0;
    const data = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '5' },
      { key: index++, label: '8' },
      { key: index++, label: '13' },

    ];

    const data1 = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '4' },



    ];
    const data2 = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '4' },



    ];

    return (
      <Modal
        offset={this.state.offset}
        closeOnTouchOutside={false}
        open={this.state.open}
        modalDidOpen={this.modalDidOpen}
        modalDidClose={this.modalDidClose}
        style={{ alignItems: "center" }} >

        {/* <View style={{ alignItems: "center", paddingBottom: 40 }}>
                <Toast ref="toast"/>
                    <Text>{ADDMODULE}</Text>

                    <TextInput placeholder={MODULE_TITLE}
                        style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                        onChangeText={(text) => this.setState({ moduledesc: text })}
                        value={this.state.moduledesc}
                         />
                    <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>


                </View>
                <DatePicker
                    style={{ textAlign: 'left', marginLeft: 0, marginTop: 5, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                    date={this.state.startDate}
                    mode="date"
                    placeholder="From Date"
                    format="YYYY-MM-DD"
                    minDate="2020-01-01"
                    maxDate="2080-12-31"
                    // minDate="01-01-2019"
                    // maxDate="01-06-2075"
                    confirmBtnText="From"
                    cancelBtnText="To"
                    showIcon={false}
                    customStyles={{
                      dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                      placeholderText: { fontSize: 15, color: "#9a73ef" },
                      dateText: { textAlign: 'left', fontSize: 15, }
                    }}
                    onDateChange={(text) => this.setState({ startDate: text })}/>
                           <DatePicker
                    style={{ textAlign: 'left', marginLeft: 0, marginTop: 5, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                    date={this.state.targetDate}
                    mode="date"
                    placeholder="To Date"
                    format="YYYY-MM-DD"
                    minDate="2020-01-01"
                    maxDate="2080-12-31"
                    // minDate="01-01-2019"
                    // maxDate="01-06-2075"
                    confirmBtnText="From"
                    cancelBtnText="To"
                    showIcon={false}
                    customStyles={{
                      dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                      placeholderText: { fontSize: 15, color: "#9a73ef" },
                      dateText: { textAlign: 'left', fontSize: 15, }
                    }}
                    onDateChange={(text) => this.setState({ targetDate: text })}/>
                <View style={{ flexDirection: 'row', marginTop: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>
                    <TouchableOpacity style={styles.opensave} onPress={this.modifyModule.bind(this)} disabled={this.state.itemPressedDisabled}>
                        <Text style={{ color: 'white' }}>SAVE</Text>
                    </TouchableOpacity>
                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                        <Text style={{ color: 'white' }}>CANCEL</Text>
                    </TouchableOpacity>
                </View> */}

        <View style={{ paddingTop: 2, }}>
          <View style={{ flexDirection: 'row', marginLeft: 10 }}>
            <Text>Task Name</Text>
            <Text style={{ color: 'red' }}>*</Text>
          </View>
          <View style={{ paddingLeft: 10, }}>

            <TextInput style={{ width: wp('80%'), height: 35, color: 'black', borderBottomWidth: 1, }}
              placeholder="Task Name"
              underlineColorAndroid='transparent'
              value={this.state.tasktitle}
              // selectionColor='white'
              onChangeText={(maintask) => this.setState({ tasktitle: maintask })}
            >
            </TextInput>

            <Text style={{ color: 'red' }}>{this.state.error1}</Text>
          </View>
          <View style={{ flexDirection: 'row', marginLeft: 10 }}>
            <Text>Roadblock Description</Text>
            <Text style={{ color: 'red' }}>*</Text>
          </View>
          <View style={{ paddingLeft: 10, }}>

            <TextInput style={{ width: wp('80%'), height: 35, color: 'black', borderBottomWidth: 1, }}
              placeholder="Road Block Description:"
              underlineColorAndroid='transparent'
              value={this.state.roadBlockDescription}
              // selectionColor='white'
              onChangeText={(roadBlockDescription) => this.setState({ roadBlockDescription: roadBlockDescription })}
            >
            </TextInput>

            <Text style={{ color: 'red' }}>{this.state.error1}</Text>
          </View>
          <View style={{ flexDirection: 'row', marginLeft: 10 }}>
            <Text>Description*</Text>
            <Text style={{ color: 'red' }}>*</Text>
          </View>
          <View style={{ paddingLeft: 10, }}>


            <TextInput style={{ width: wp('80%'), height: 35, color: 'black', borderBottomWidth: 1, }}
              placeholder='Description:'
              underlineColorAndroid='transparent'
              value={this.state.taskDescription}
              // selectionColor='white'
              onChangeText={(taskDescription) => this.setState({ taskDescription: taskDescription })}>
            </TextInput>
            <Text style={{ color: 'red' }}>{this.state.error2}</Text>
          </View>
          <View style={{ flexDirection: 'row', marginLeft: 10 }}>
            <Text>Acceptance Criteria/Definition of Done</Text>
            <Text style={{ color: 'red' }}>*</Text>
          </View>
          <View style={{ paddingLeft: 10, }}>


            <TextInput style={{ width: wp('80%'), height: 35, color: 'black', borderBottomWidth: 1, }}
              placeholder="Acceptance Criteria/Definition of Done"
              underlineColorAndroid='transparent'
              value={this.state.acceptanceCriteria}
              // selectionColor='white'
              onChangeText={(acceptanceCriteria) => this.setState({ acceptanceCriteria: acceptanceCriteria })}>
            </TextInput>
            <Text style={{ color: 'red' }}>{this.state.error2}</Text>
          </View>
          <View style={{ flexDirection: 'row' }}>
            <View style={{ padding: 5, width: '48%', flexDirection: 'row' }}>
              <Text>Select User</Text>
              <Text style={{ color: 'red' }}>*</Text>
            </View>

            <View style={{ padding: 5, width: '48%', flexDirection: 'row' }}>

              <Text>Story Points</Text>
              <Text style={{ color: 'red' }}>*</Text>
            </View>
          </View>
          <View style={{ paddingTop: 2, flexDirection: 'row' }}>

            <SearchableDropdown
              placeholder={this.state.assignedName}
              onTextChange={text => console.log(text)}
              // value={this.state.assignedName}
              // onItemSelect={item => item.name}
              onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
              placeholderTextColor='black'
              containerStyle={{ padding: 5, width: '48%' }}
              textInputStyle={{
                padding: 12,
                borderWidth: 1,
                borderColor: '#ccc',
                // backgroundColor: '#FAF7F6',
              }}
              itemStyle={{
                padding: 10,
                marginTop: 2,
                backgroundColor: '#FAF9F8',
                borderColor: '#bbb',
                borderWidth: 1,
              }}
              itemTextStyle={{

                color: '#222',
              }}
              itemsContainerStyle={{

                // maxHeight: '60%',
              }}
              items={this.state.resource}

              defaultIndex={2}

              // placeholder=""

              resetValue={false}

              underlineColorAndroid="transparent"

            />
            <Text style={{ color: 'red' }}>{this.state.error3}</Text>
            {/* <Text style={{ marginLeft: 10, paddingTop: 10 }}>Story Points</Text> */}



            <ModalSelector
              style={{ width: '48%' }}
              //  value={this.state.storyPoints}
              data={data}
              initValue="Select something yummy!"
              // supportedOrientations={['landscape']}
              accessible={true}
              optionContainerStyle={{ backgroundColor: 'white' }}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ storyPoints: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '100%', marginLeft: '2%', marginTop: '4%', color: 'black' }}
                editable={false}
                placeholder="Select Story Points!"
                value={this.state.storyPoints} />

            </ModalSelector>
          </View>


          <View style={{ flexDirection: 'row' }}>
            <View style={{ padding: 5, width: '48%', flexDirection: 'row' }}>
              <Text>Severity</Text>
              <Text style={{ color: 'red' }}>*</Text>
            </View>

            <View style={{ padding: 5, width: '48%', flexDirection: 'row' }}>

              <Text>Priority</Text>
              <Text style={{ color: 'red' }}>*</Text>
            </View>
          </View>
          <View style={{ paddingTop: 2, flexDirection: 'row' }}>


            <ModalSelector
              style={{ width: '48%' }}
              //  value={this.state.storyPoints}
              data={data1}
              initValue="Select Severity"
              // supportedOrientations={['landscape']}
              accessible={true}
              optionContainerStyle={{ backgroundColor: 'white' }}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ severitySelected: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '96%', marginLeft: '2%', color: 'black' }}
                editable={false}
                placeholder="Select Severity"
                value={this.state.severitySelected} />

            </ModalSelector>



            {/* <Text style={{ marginLeft: 10, paddingTop: 10 }}>Priority Level</Text> */}

            <ModalSelector
              style={{ width: '48%' }}
              data={data1}
              initValue="Select Priority "
              // supportedOrientations={['landscape']}
              optionContainerStyle={{ backgroundColor: 'white' }}
              accessible={true}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ prioritySelected: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '100%', marginLeft: '2%', color: 'black' }}
                editable={false}
                placeholder="Select Priority  "
                value={this.state.prioritySelected} />

            </ModalSelector>
          </View>

          <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
            <TouchableOpacity style={styles.opensave} onPress={() => { this.addRoadblock() }} disabled={this.state.itemPressedDisabled}>
              <Text style={{ color: 'white' }}>SAVE</Text>
            </TouchableOpacity>

            <TouchableOpacity style={styles.opencancel} onPress={() => this.props.navigation.goBack()}>
              <Text style={{ color: 'white' }}>CANCEL</Text>

            </TouchableOpacity>

          </View>

        </View>

      </Modal>


    );

  }

}
//Styles for UI

const styles = StyleSheet.create(
  {
    MainContainer:
    {
      flex: 1,
      width: Dimensions.get('window').width,
      height: Dimensions.get('window').height
    },
    bottomView: {
      flexDirection: 'row',
      justifyContent: 'center',
      position: 'absolute',
      height: FOOTER_MAX_HEIGHT,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: 'black',
      alignItems: 'center'
    },

    textStyle: {
      color: '#fff',
      fontSize: 18
    },
    container: {
      flex: 1,
      width: '90%',
      paddingLeft: hp('2%'),
    },
    footer: {
      position: 'absolute',
      flex: 0.1,
      left: 0,
      right: 0,
      bottom: -10,
      backgroundColor: 'green',
      flexDirection: 'row',
      height: 80,
      alignItems: 'center',
    },
    bottomButtons: {
      alignItems: 'center',
      justifyContent: 'center',
      flex: 1,
    },
    footerText: {
      color: 'white',

      alignItems: 'center',
      fontSize: 18,
    },
    buttonContainer: {
      width: wp('90%'),
      alignSelf: 'baseline',
      marginBottom: 25,
      color: '#d2691e',
      marginLeft: 4,



    },
    signupButton: {

      backgroundColor: '#ffffff',
    },
    subcontainer: {
      flex: 2,
      flexDirection: 'row',
      paddingTop: 40
    },
    signUpText0: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

    },
    signUpText1: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

      paddingLeft: 10,
    },
    end: {

      alignItems: 'flex-end',

    },
    end1: {
      flex: 2,
      height: '50%',
      paddingTop: 20,
      justifyContent: 'space-between',

      flexDirection: 'row',
    },
    s: {
      justifyContent: 'center',

      backgroundColor: '#ed7070',
      shadowOffset: { width: 50, height: 50 },
      alignItems: 'center',
      width: wp('40%'),
      height: hp('12%'),

    },
    signUpText2: {
      fontSize: 10,
      marginLeft: 200,
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

      //  marginRight: 10,
      //textAlign: "right"

    },
    signUpText3: {

      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,

      alignItems: 'center',
    },
    signUpText4: {
      fontSize: 12,
      paddingTop: 10,


      alignItems: 'center',
    },
    signup: {
      //paddingTop:20,
      color: "#FFF",

    },
    boxone: {
      flex: 1,
      marginTop: 5,

    },
    boxtwo: {
      flex: 1,

    },
    boxthree: {
      flex: 1,

    },
    box: {
      flexDirection: 'row',
      position: 'relative',
      marginBottom: 10,


    },
    signUpText: {
      fontSize: 20,
      justifyContent: 'center',


      color: 'white',
      alignSelf: 'center',
    },
    buttonView: {
      display: 'flex',
      justifyContent: 'center',
      flexDirection: 'row',
      marginTop: 10,
    },
    containerButton: {
      paddingTop: 30,
      marginLeft: 20,
      marginRight: 20,
      flex: 1,
    },
    opencancel: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
    opensave: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },

  });



