/*
FileName:Login.js
Version:1.3
Purpose:Navgate to all Admin classes from Here and logout
Devloper:Mahesh,Rishitha
*/
import React, { Component } from 'react';
import { Text, View, TextInput, Image, StyleSheet, TouchableOpacity, ImageBackground, Alert } from 'react-native';
import Icon from 'react-native-vector-icons/FontAwesome';
import MyTask from '../UserComponents/UserMyTask';
import AsyncStorage from '@react-native-community/async-storage';
import RadioGroup from 'react-native-radio-button-group';
import { API } from "../WebServices/RestClient";
import log from '../LogFile/Log';
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import jwt_decode from "jwt-decode";


import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
import RadioButtonRN from 'radio-buttons-react-native';
export default class Login extends Component {

  constructor(props) {
    super(props);
    this.state = {
      isLoading: false,
      username: '',
      password: '',
      cropcode: '',
      showPass: true,
      press: false,
      usertype: '',
      action: ''
    };
  }


  showPass = () => {
    if (this.state.press == false) {
      this.setState({ showPass: false, press: true, })
    }
    else {
      this.setState({ showPass: true, press: false, })
    }
  }

  componentDidMount() {
    // db.initDB();
    log("Debug", "Login Screen is Loaded");
  }

  //Checking for Validation
  isValid() {

    const { username, password, } = this.state;
    let valid = false;
    var regex = /^[A-Za-z0-9 ]+$/;
    // if (username.length === 0 || regex.test(username) === false) {
    if (username.length === 0) {
      log("Warn", "UserName have not entered as per given");
      alert("Enter username ");
    }
    //  else if (!isNaN(username)) {
    //   log("Warn", "UserName should not contain special characters");
    //   alert("Please Enter Only Characters");
    // }
    else if (password.length === 0) {
      alert("Enter Password");
      log("Warn", "Password must be entered");
    }
    // else if (cropcode.length === 0) {
    //   alert("Enter cropcode");
    //   log("Warn", "corpcode should be entered");
    // }
    // else if (usertype.length === 0) {
    //   alert("Enter usertype");
    //   log("Warn", "usertype must be selected");
    // }

    else {
      valid = true;
    }
    return valid;
  }

  //Notification Token And user id inserting
  onSignIn1 = () => {
    // alert(this.state.taskTitle)
    const { id } = this.state;
    // alert(id)
    // if(id ==='undefined'){
    //   alert("Relogin Again")
    // }
    // else{
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("userId", (err, res) => {
          const userId = res;
    log("Info", " addSubTask() is used to add sub task");


        // alert("deviceid" + userId)
        if (userId === null) {
          alert("Your Device Id  is not detected. \n Please relaunch app and Try again...")
          this.setState({
          
            username: '',
            password: ''
        })
   
        
        }
        else{
          this.onSignIn()
        }
      })
    })
      }
  //User or Admin Login 
  onSignIn() {
    // alert("hello")
    // alert(API)
    log("Info", "onSignIn() is used for login purpose and based on usertype data is authorizised");
    const { username, password, action, } = this.state;
    if (this.isValid()) {
      console.log(username + "" + password);
      fetch(API + 'authentication.php', {
        method: 'POST',
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({
          username: username,
          password: password,
          action: 'login',
          // crop: cropcode,
          // utype: usertype,
        })
      }).then((response) => response.json())
        .then((responseJson) => {
          console.log(JSON.stringify(responseJson));
          // alert(JSON.stringify(responseJson))

          // if (responseJson.status === 'TRUE') {
          //   AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
          //   const tokenDetails = jwt_decode(responseJson.jwt);
          //   console.log(tokenDetails.data)
          //   AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
          //   // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
          //   AsyncStorage.setItem('status', tokenDetails.data.empStatus)


          //   AsyncStorage.setItem('userToken', tokenDetails.data.empId);
          //   AsyncStorage.setItem('userName', tokenDetails.data.userName);
          //   AsyncStorage.setItem('emp_role', tokenDetails.data.role);
          //   AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
          //   AsyncStorage.setItem('fullName', tokenDetails.data.fullName);
          //   AsyncStorage.setItem('projectId', tokenDetails.data.projectId);

          //   this.props.navigation.navigate("MyTask");

          // }
          if (responseJson.status === 'TRUE') {
            if (responseJson.role === "admin" || responseJson.role === "Admin") {
              AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
              const tokenDetails = jwt_decode(responseJson.jwt);
              //  console.log(tokenDetails.data)
              AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
              //   // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
              AsyncStorage.setItem('status', tokenDetails.data.empStatus)


              AsyncStorage.setItem('userToken', tokenDetails.data.empId);
              AsyncStorage.setItem('userName', tokenDetails.data.userName);
              AsyncStorage.setItem('emp_role', tokenDetails.data.role);
              AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
              AsyncStorage.setItem('fullName', tokenDetails.data.fullName);
              AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
              this.testNotification();

              // this.props.navigation.navigate("AdminReports");
            }
            else {
              AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
              const tokenDetails = jwt_decode(responseJson.jwt);
              //  console.log(tokenDetails.data)
              AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
              //   // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
              AsyncStorage.setItem('status', tokenDetails.data.empStatus)


              AsyncStorage.setItem('userToken', tokenDetails.data.empId);
              AsyncStorage.setItem('userName', tokenDetails.data.userName);
              AsyncStorage.setItem('emp_role', tokenDetails.data.role);
              AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
              AsyncStorage.setItem('fullName', tokenDetails.data.fullName);
              AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
              this.testNotification1()
              // this.props.navigation.navigate("MyTask");
            }
          }

          else if (responseJson.status === "False") {
            AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
            AsyncStorage.setItem('empId', tokenDetails.data.empId) //store the token information  with exp
            AsyncStorage.setItem('user', tokenDetails.data.username) //store the token information  with exp
            // dispatch(setCurrentUser(response)); //store the user information
            // setRedirect(true)
            console.warn(responseJsone)
            Alert('warning', responseJsone)
            // store.dispatch(isLoaded());
          }
          else {
            console.log(JSON.stringify(responseJson));
            alert(JSON.stringify(responseJson.message))
            // alert("Login Details are Invalid")
            log("Warn", "UserName and Password is not entered correctly");

          }

        }).catch((error) => {
          console.error(error);
          log("Error", "Login Error");
        });

    };
  }


  // Notification Token And user id inserting
  testNotification = () => {
    // alert(this.state.taskTitle)
    const { id } = this.state;
    // alert(id)



    log("Info", " addSubTask() is used to add sub task");


    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      AsyncStorage.getItem("userId", (err, res) => {
        const userId = res;


        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }



          else {
            fetch(API + 'device_store.php', {
              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                device_id: userId,
                empId: empId,
                action: "store_device",

              })
            }).then((response) => response.json())
              .then((responseJson) => {
                // alert(JSON.stringify(responseJson));
                console.log(JSON.stringify(responseJson));

                if (responseJson.status === 'True') {
                  this.props.navigation.navigate("AdminReports1");
                  // alert("Sucess")
                  console.log("done")
                  // this.props.navigation.goBack();
                  this.setState({ open: false })
                }
              }).catch((error) => {
                console.error(error);
                log("Error", "addSubTask  error");
              });


          }
          // }
        });
      });
    });


  };

  //Notification Token And user id inserting
  testNotification1 = () => {
    // alert(this.state.taskTitle)
    const { id } = this.state;
    // alert(id)
    // if(id ==='undefined'){
    //   alert("Relogin Again")
    // }
    // else{

    log("Info", " addSubTask() is used to add sub task");


    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      AsyncStorage.getItem("userId", (err, res) => {
        const userId = res;
        // alert("deviceid" + userId)
        // if (userId === null) {
        //   alert("Relogin Again")
        //   this.setState({
          
        //     username: '',
        //     password: ''
        // })

        // }
        // else {
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              console.log(state.type);
              log("Warn", "No internet connection");
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            }



            else {
              fetch(API + 'device_store.php', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  device_id: userId,
                  empId: empId,
                  action: "store_device",

                })
              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert(JSON.stringify(responseJson));
                  console.log(JSON.stringify(responseJson));

                  if (responseJson.status === 'True') {
                    this.props.navigation.navigate("UserDashboard")
                    // alert("Sucess")
                    console.log("done")
                    // this.props.navigation.goBack();
                    this.setState({ open: false })
                  }
                }).catch((error) => {
                  console.error(error);
                  log("Error", "addSubTask  error");
                });


            }
            // }
          });
        // }

      });

    });
    // }

  };



  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#283B53' />
        </View>
      );

    }

    const data = [
      {
        label: 'admin'
      },
      {
        label: 'user'
      }
    ];

    return (
      <View style={styles.container}>
        <View style={styles.form}>
          <View style={styles.logoView}>
            {/* <ImageBackground
              style={styles.logoContainer}
              source={require('../Images/cloud.png')}
              imageStyle={{ resizeMode: 'cover', }} > */}
            <ImageBackground
              style={styles.logoContainer}
              source={require('../Images/agilecloud.png')}
              imageStyle={{ width: 190, alignItems: 'center', }} >
              {/* <Image style={styles.logo} source={require('../Images/cptms.png')} /> */}
              {/* <Image style={styles.logo} source={require('../Images/agile1.png')} /> */}
            </ImageBackground>
          </View>

          <View style={styles.inputContainer}>
            <Icon style={styles.inputIcon}
              name='user'
              color='white'
              type='MaterialCommunityIcons'
              size={30}
            />
            <TextInput style={{ width: 265, height: 45, color: 'white' }}
              selectionColor='white'
              placeholder="Username *"
              autoCapitalize='none'
              placeholderTextColor={'rgba(255,255,255,0.3)'}
              keyboardType="email-address"
              underlineColorAndroid='transparent'
              onChangeText={(username) => this.setState({ username })} />
          </View>
          <View style={styles.inputContainer}>
            <Icon style={styles.inputIcon}
              name='lock'
              color='white'
              type='MaterialCommunityIcons'
              size={30}
            />
            <TextInput style={styles.inputs}
              selectionColor='white'
              placeholder="Password *"
              autoCapitalize='none'
              placeholderTextColor={'rgba(255,255,255,0.3)'}
              secureTextEntry={this.state.showPass}
              underlineColorAndroid='transparent'
              onChangeText={(password) => this.setState({ password })} />
            <TouchableOpacity style={styles.eyeIcon}
              onPress={this.showPass.bind(this)}>
              <Icon
                name={this.state.press == false ? 'eye-slash' : 'eye'}
                size={22} color="white" />
            </TouchableOpacity>
          </View>
          {/* <View style={styles.inputContainer}>
            <Icon style={styles.inputIcon}
              name='lock'
              color='white'
              type='MaterialCommunityIcons'
              size={30}
            />
            <TextInput style={styles.inputs}
              selectionColor='white'
              placeholderTextColor={'rgba(255,255,255,0.3)'}
              placeholder="corp code *"
              autoCapitalize='none'
              underlineColorAndroid='transparent'
              onChangeText={(cropcode) => this.setState({ cropcode })} />
          </View> */}
          {/* <RadioButtonRN
            data={data}
            box={false}
            // horizontal={true}
            style={styles.types}
            selectedBtn={(option) => this.setState({ usertype: option.label })}
            circleStyle={{ fillColor: 'white', borderColor: 'white' }}
            icon={
              <Icon
                name="check-circle"
                size={25}
                color="white"
               
              />
            }
          /> */}
          {/* <View style={styles.radioContainer}>
            <RadioGroup
              horizontal
              options={[
                {
                  id: 'admin',
                  labelView: (
                    <Text>
                      <Text style={{ color: 'white' }}>Admin
                  </Text>
                    </Text>
                  ),
                },
                {
                  id: 'user',
                  labelView: (
                    <Text>
                      <Text style={{ color: 'white' }}>User
                  </Text>
                    </Text>
                  ),
                },
              ]}
              activeButtonId={''}
              circleStyle={{ fillColor: 'white', borderColor: 'white' }}
              onChange={(option) => this.setState({ usertype: option.id })} />
          </View>*/}
          <TouchableOpacity style={[styles.buttonContainer, styles.signupButton]}
            onPress={() => NetInfo.fetch().then(state => {
              // alert(state.type);
              if (state.type == "none" || state.type == "unknown") {
                console.log(state.type);
                Snackbar.show({
                  title: 'No Internet Connection',
                  backgroundColor: 'red',
                  duration: Snackbar.LENGTH_LONG,
                });
              }
              else {
                this.onSignIn1()
              }
            })
            } >
            <Text style={styles.signUpText}>Login</Text>
          </TouchableOpacity>
          <TouchableOpacity onPress={() => this.props.navigation.navigate("Forgot")} style={[styles.buttonContainerforgot,]}>
            <Text style={styles.signUpTextforgot}>Forgot Password ?</Text>
            <Text style={styles.signUpTextforgotred}>Click here</Text>
          </TouchableOpacity>
          <View >
            {/* <Text style={{ color: 'white' }} onPress={()=>this.props.navigation.navigate('RegisterUser')}> New User ? </Text> */}
          </View>
        </View>

      </View>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  container: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
  },
  logoContainer: {
    marginLeft: 95,
    height: 150,
    width: 150,

  },
  stretch: {
    width: 200,
    height: 200,
    marginLeft: 80
  },
  // logo: {
  //   top: 40,
  //   marginLeft: 38,
  //   height: 80,
  //   width: 100,
  // },
  logo: {
    top: 60,
    marginLeft: 30,
    height: 40,
    width: 100,
  },
  logoView: {
    position: 'absolute',
    top: -80,

  },
  form: {
    backgroundColor: '#00A2C1',
    // backgroundColor: '#36ea9f',
    padding: 25,
    paddingTop: 60,
    borderRadius: 15,
  },
  radioContainer: {
    marginTop: -4,
    marginBottom: 20,
    marginLeft: 3,
    width: 250,
  },
  inputContainer: {
    borderBottomColor: '#FFFFFF',
    // backgroundColor: '#36ea9f',
    backgroundColor: '#00A2C1',
    borderBottomWidth: 1.8,
    width: 290,
    height: 38,
    marginBottom: 40,
    flexDirection: 'row',
    alignItems: 'center',
  },
  inputs: {
    width: 235,
    height: 45,
    color: 'white',
  },
  eyeIcon: {

  },
  inputIcon: {
    width: 30,
    height: 30,
    marginLeft: 1,
    justifyContent: 'center'
  },

  buttonContainer: {
    height: 45,
    justifyContent: 'center',
    alignItems: 'center',
    marginBottom: 10,
    width: 290,
    borderRadius: 30,
  },
  buttonContainerforgot: {
    height: 45,
    justifyContent: 'center',
    alignItems: 'center',
    marginBottom: 10,
    width: 290,
    borderRadius: 30,
    flexDirection: 'row',

  },
  signupButton: {
    backgroundColor: "#ffffff",
  },

  signUpText: {
    fontSize: 20,
    color: '#00A2C1',
  },
  signUpTextforgot: {
    fontSize: 14,
    color: 'white',
    padding: 2
  },
  signUpTextforgotred: {
    fontSize: 14,
    color: 'red',
    padding: 2
  },
  TextComponentStyle: {
    fontSize: 20,
    color: "#000",
    textAlign: 'center',
    marginBottom: 15
  },
  types: {
    // marginHorizontal: 5,
    borderWidth: 1,
    borderColor: '#bbb',
    padding: 4,
    borderRadius: 3,
    flexDirection: 'column',
    marginVertical: 10,

    // backgroundColor: '#fff'
  }
});