import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard,
  Button
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';
import DateRangePicker from "react-native-daterange-picker";
import moment from "moment";

export default class ReportUserSprintVelocity extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintVelocity: [],
      sprint: [],
      selectedIndVelocity: [],
      // indWorkload: [],
      dataSource: [],
      dataSource1: [],
      visible: true,
      resource: [],
      resource1: [],
      resource2: [],
      startDate: null,
      endDate: null,
      displayedDate: moment(),
      minDate: moment().set("date", 1),
      maxDate: moment().set("date", 31),


    }

  }
  setDates = (dates) => {
    this.setState({
      ...dates,
    });
  };


  componentDidMount() {

    this.Network();

  }



  //Getting the Srpint velocity
  Network() {

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          // alert(projectId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'sprintVelocity', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId
                })


              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Velocity1" + sprintVelocity);
                  //   alert(JSON.stringify(responseJson))

                  this.setState({
                    sprintVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }
  //Getting the Srpint velocity

  Reports() {
    // const { startDate, endDate } = this.state;

    const filter = [{
      "startDate": moment(this.state.startDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
      "endDate": moment(this.state.endDate).format('YYYY-MM-DD[T]hh:mm:ss.SSS[Z]'),
      // "key": "selection"
    }]
    // alert(responseJson.filter)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          // alert(projectId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'sprintVelocity', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId,
                  filter: filter,
                })


              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Velocity1" + sprintVelocity);
                  //   alert(JSON.stringify(responseJson))

                  this.setState({
                    sprintVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }
  example = () => {

    this.setState({ visible: !this.state.visible })
  }

  render() {
    const { startDate, endDate, displayedDate, minDate, maxDate } = this.state;
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    var sprintDataX = [];
    var sprintDataY = [];
    // alert(JSON.stringify(this.state.sprintVelocity))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
      );

    })
    // alert(JSON.stringify(sprintDataX))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed) })
      );
    })

    // alert(JSON.stringify(sprintDataX))

    const sprintData = [

      {
        seriesName: 'series1',
        color: 'grey',


        data: sprintDataX

        // data: this.state.sprintVelocity.map(x => x.estimated)
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.estimated)}],
        // data1:this.state.sprintVelocity.map(y => y.sprint)
      },

      {
        seriesName: 'series2',
        color: 'green',
        labelWidth: 200,
        label: "Completed",
        data: this.state.sprintVelocity.map(x => parseInt(x.completed)),
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.completed)}],

      }
    ]



    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >

        <Container>

          <View style={styles.calendar}>

            <DateRangePicker
              style={{ zIndex: 1, top: 100, flex: 1 }}
              containerStyle={{ marginTop: -200 }}
              onChange={this.setDates}
              startDate={startDate}
              endDate={endDate}
              // minDate={minDate}
              // maxDate={maxDate}
              presetButtons={true}
              completed
              range
              displayedDate={displayedDate}
              moment={moment}

            >
              <View>
                <TouchableOpacity onPress={() => this.example()} style={{ backgroundColor: 'green', borderRadius: 30, margin: 10, padding: 5, flexDirection: 'row' }}><Text style={{ color: 'white' }}>Open Calendar </Text></TouchableOpacity>
                {/* <Image onClick={this.handleClick} style={{ width: wp('9%'), height: hp('5%'), margin: 5 }} source={require('../Images/calender.jpeg')} /> */}
              </View>
            </DateRangePicker>

            <TouchableOpacity style={{ backgroundColor: 'grey', borderRadius: 30, margin: 10, padding: 5 }} onPress={() => { this.Reports() }}>
              <Text style={{ color: 'white', }}>Show Reports</Text>
            </TouchableOpacity>
          </View>

          <Content>

            {/* Sprint Velocity */}
            <View style={{ zIndex: 1, flex: 1, marginTop: 10, marginBottom: 10 }}>


              <Text style={{ padding: 10, fontWeight: 'bold' }}>Sprint Velocity</Text>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>


              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>

                <PureChart data={sprintData}
                  type='bar'
                  showEvenNumberXaxisLabel={false}
                  width={'100%'}
                  labelColor={'black'}
                  defaultColumnWidth={105}
                />


              </ScrollView>
            </View>


          </Content>
        
            <View
              style={{
                backgroundColor: 'black',
                flexDirection: 'row',
                justifyContent: 'center',
                // position: 'absolute',
                height: FOOTER_MAX_HEIGHT,
                alignItems: 'center',
                left: 0,
                right: 0,
              }}>

              <Text style={{ color: 'white' }}>Confirm Date range</Text></View> 
        </Container>


      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  submit: {
    flex: 1,
    ...Platform.select({
      ios: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 10
      },
      android: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 70
      },
    }),
  },
  mobile: {
    flex: 1,
    ...Platform.select({
      ios: {
        marginTop: 12
      },
      android: {

      },
    }),
  },
  role: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row', marginTop: 10
      },
      android: {
        flexDirection: 'row',
        paddingTop: 10,

      },
    }),
  },
  calendar: {

    ...Platform.select({
      ios: {
        flexDirection: 'row', zIndex: 100
      },
      android: {
        flexDirection: 'row',

      },
    }),
  },
  bottomView: {
    flexDirection: 'row',
    justifyContent: 'center',
    position: 'absolute',
    height: FOOTER_MAX_HEIGHT,
    bottom: 0,
    left: 0,
    right: 0,
    backgroundColor: 'black',
    alignItems: 'center'
  },


});
