/*
FileName:UserDashboard.js
Version:1.0.0
Purpose:Working Hours showing in table formate
Devloper:Mahesh,Santhosh
*/
import React, { Component } from 'react';
import {
    Platform, StyleSheet, TextPropTypes, Picker, Text, Button, View, Image, StatusBar, Dimensions, TextInput, Alert,
    KeyboardAvoidingView,
    TouchableWithoutFeedback,
    FlatList,
    Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import UserDatabase from "../OfflineDB/UserDatabase";
const db = new UserDatabase();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import Modal from "react-native-simple-modal";
import ModalSelector from 'react-native-modal-selector';
// const check = new Main()
import {
    DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';
import moment from "moment";
import DateRangePicker from "react-native-daterange-picker";
import { DataTable } from 'react-native-paper';



export default class UserDashboard extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: false,
            isVisibleB: false,
            sprintName: 'Select User',
            epicName: 'Select Epic',
            abc: [],
            squadName: '',

        }

        // AsyncStorage.getItem("cropcode", (err, res) => {
        //     this.setState({ squadName: res });
        //     console.warn("squadname" + this.state.squadName);
        // });

    }
    moveUp = () => this.setState({ offset: -110 });

    resetPosition = () => this.setState({ offset: 0 });

    openModal = () => this.setState({ open: true });

    closeModal = () => {
        //this.props.navigation.goBack();

        this.setState({
            open: false,
            // ProjectTitle: '',
            // ProjectDescription: '',
            error1: '',
            error2: '',
            error3: '',
            group_name: '',


        });
    }


    //this methos is used to ask the user about confirm about 
    logOutOption() {
        Alert.alert(
            'Alert',
            'Do you want to Logout',
            [
                {
                    text: 'Cancel',
                    onPress: () => console.log('Cancel Pressed'),
                    style: 'cancel',
                },
                { text: 'OK', onPress: () => this.logOut() },
            ],
            { cancelable: false },
        );
    }

    //this method is used for logout the application and also clear the asyncstorage .
    logOut() {
        AsyncStorage.clear();
        db.deleteUser();
        console.warn("result");
        this.props.navigation.navigate('Auth');
    }

    navigateToScreen = (route) => (
        () => {
            const navigateAction = NavigationActions.navigate({
                routeName: route
            });
            this.props.navigation.dispatch(navigateAction);
            // this.props.navigation.dispatch(DrawerActions.closeDrawer());
        })


    componentDidMount() {

        this.GetStatus();
    }


    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects()//For Getting Project List in Offline
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)

                            // alert(JSON.stringify(responseJson))

                            //alert(JSON.stringify(responseJson))

                            if (responseJson.status == 'True') {



                                this.setState({
                                    abc: responseJson.data
                                });


                            } else {
                                this.setState({
                                    abc: responseJson.data
                                });
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }


    isValid() {
        const { squadName } = this.state;


        let valid = false;

        if (squadName.length === 0) {
            this.setState({ error1: 'project name should not be empty' });
            log("Warn", "project name should not be empty");
            // alert("project title should not be empty ");

        }

        else {
            valid = true;
        }
        return valid;
    }//isValid method end

    verifyProjectTitle(ProjectTitle) {
        var reg = /^[^!-\\/:-@\\[-`{-~]+$/;
        return reg.test(ProjectTitle);
    }


    //to add the new project from user 
    addGroup = () => {
        log("Info", "addGroup() method is used to add new project at user side");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            }
            else {
                const { squadName, } = this.state;
                if (this.isValid()) {
                    // alert(group_name)
                    // alert(this.state.selectedItems)

                    this.setState({ itemPressedDisabled: true })
                    AsyncStorage.multiGet(["userToken", "userName", "fullName"], (err, response) => {
                        const empId = response[0][1];
                        const userName = response[1][1];
                        // console.warn("userToken" + userToken)
                        const fullName = response[2][1];


                        fetch(API + 'squads.php', {
                            method: 'POST',
                            headers: {
                                'Accept': 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                squadName: squadName,
                                username: userName, //Async
                                action: "new_squad",
                                empId: empId
                            })
                        }).then((response) => response.json())
                            .then((responseJson) => {
                                console.log(JSON.stringify(responseJson));
                                console.log(responseJson);
                                // alert(JSON.stringify(responseJson))

                                if (responseJson.status === 'True') {
                                    alert(responseJson.message)
                                    this.GetStatus()
                                    this.refs.toast.showBottom('Project Created Succesfully');
                                    this.setState({ itemPressedDisabled: false })
                                    console.log("done")
                                    this.setState({
                                        open: false,
                                        squadName: '',

                                    })
                                   

                                }
                            }).catch((error) => {
                                console.error(error);
                                log("Error", "error in project adding");
                            });
                    });

                    this.closeModal();
                }
            }

        });


    };

    dashboard(projects, index) {
        console.log(projects);
        console.log(index);
        // alert(projects.value)
        log("Info", "ReassignStory() method is used to navigate User My Taskscreen");
        this.props.navigation.navigate('MyTask',
            //  this.setState({
            //                         squadName: projects.value
            //                     })
            AsyncStorage.setItem('cropcode', projects.value))
        //  { id: projects.id,squadName:projects.value });
    }
    render() {



        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }
        var width = Dimensions.get('window').width; //full width
        var height = Dimensions.get('window').height; //full height
        return (

            <Container style={{ width: width }}>

                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 ,flexDirection:'row'}}>
                    <Icon name="plus-circle" style={{ color: 'white', paddingRight: 5 }} size={25} />

                        <TouchableOpacity onPress={this.openModal}>
                            <Text style={{ width: 100, borderRadius: 20, height: 45, flexDirection: 'row', color: 'white',padding:5 }}>
                                Add Project
                        </Text>
                        </TouchableOpacity>
                    </View>
                    <View style={{ marginTop: 20 ,flexDirection:'row'}}>
                        <TouchableOpacity onPress={this.logOutOption.bind(this)}>
                            {/* <Text style={{ borderRadius: 20, height: 45,color: 'white' }}>Logout</Text> */}
                            <Icon name="power-off" style={{ color: 'white'}} size={25} />

                        </TouchableOpacity>
                    </View>
                </Header>
                {/* 
                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </View>

                    <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                        <Text style={{ width: 300, borderRadius: 20, height: 45, marginTop: 20, flexDirection: 'row', color: 'white' }}>Dashboard</Text>



                    </View>

                </Header> */}
                <Content style={{ width: width }}>





                    <View style={{ width: width }}>


                        {this.state.abc.map((projects, index) => (
                            <DataTable >
                                <DataTable.Row style={{ margin: 1, width: width }} key={index}>
                                    <TouchableOpacity
                                        style={{ width: width, }}
                                        onPress={() => this.dashboard(projects, index)}
                                    // onPress={() => this.props.navigation.navigate('UserMyTask', { id: projects.id,squadName: projects.value, })}
                                    >
                                        <DataTable.Cell style={{ backgroundColor: projects.color, width: '92%', height: 150, marginTop: 5, marginBottom: 15, justifyContent: 'center' }}><Text style={{ color: 'black', }}>{projects.value}           </Text></DataTable.Cell>

                                    </TouchableOpacity>

                                </DataTable.Row>


                            </DataTable>
                        )
                        )}


                    </View>


                </Content>

                <Modal
                    // offset={this.state.offset}
                    open={this.state.open}
                    closeOnTouchOutside={false}
                    modalDidOpen={this.modalDidOpen}
                    modalDidClose={this.modalDidClose}
                    style={{ alignItems: "center" }}
                // disableOnBackPress={false}
                >

                    <View style={{ alignItems: "center", }}>

                        <Text>Project Name</Text>

                        <TextInput placeholder='Project Name'
                            style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                            maxLength={50}
                            onChangeText={(text) => this.setState({ squadName: text })}
                            value={this.state.squadName} />
                        <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>
                        <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error3}</Text>


                    </View>
                    <View style={{ flexDirection: 'row', marginBottom: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>

                        <TouchableOpacity style={styles.opensave} onPress={this.addGroup} disabled={this.state.itemPressedDisabled}>
                            <Text style={{ color: 'white' }}>SAVE</Text>

                        </TouchableOpacity>
                        <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                            <Text style={{ color: 'white' }}>CANCEL</Text>
                        </TouchableOpacity>

                    </View>
                </Modal>


            </Container>
            // </KeyboardAvoidingView >
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        width: '90%',
        paddingLeft: hp('2%'),
    },
    footer: {
        position: 'absolute',
        flex: 0.1,
        left: 0,
        right: 0,
        bottom: -10,
        backgroundColor: 'green',
        flexDirection: 'row',
        height: 80,
        alignItems: 'center',
    },
    bottomButtons: {
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    footerText: {
        color: 'white',
        fontWeight: 'bold',
        alignItems: 'center',
        fontSize: 18,
    },
    buttonContainer: {
        width: wp('90%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,



    },
    signupButton: {

        backgroundColor: '#ffffff',
    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',
        paddingTop: 40
    },
    signUpText0: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

    },
    signUpText1: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

        paddingLeft: 10,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 2,
        height: '50%',
        paddingTop: 20,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),

    },
    signUpText2: {
        fontSize: 13,
        marginLeft: 20,

        color: 'green',
        paddingTop: 10,
    },
    signUpText3: {

        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,

        alignItems: 'center',
    },
    signUpText4: {
        fontSize: 13,
        paddingTop: 10,


        alignItems: 'center',
    },
    signup: {
        color: "#FFF",

    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 10,


    },
    opencancel: {
        // flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'red', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center',paddingLeft:10,paddingRight:10
            },
            android: {
                backgroundColor: 'red', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center',paddingLeft:10,paddingRight:10
            },
        }),
    },
    opensave: {
        // flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center',paddingLeft:10,paddingRight:10
            },
            android: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center',paddingLeft:10,paddingRight:10
            },
        }),
    },

    top: {
        // flex: 1,
        ...Platform.select({
            ios: {
                flex: 1, marginTop: 10, marginBottom: 10,
            },
            android: {
                flex: 1, marginTop: 10, marginBottom: 10, height: 400
            },
        }),
    },
    signUpText: {
        fontSize: 13,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
});