/*
FileName:UserProjects.js
Version:1.0.4
Purpose:For getting Projects List and changeing project
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, TextPropTypes,  Text, View, Image,Picker, StatusBar, Dimensions, TextInput, Alert } from 'react-native';
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
// import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
// import { Dropdown } from 'react-native-material-dropdown';
import RNPickerSelect from 'react-native-picker-select';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
const check = new Main()
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';


import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';

export default class UserProjects extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: true,
            profileInfo: [],
            data2: [],
            empstatus: '',
            city: null,
            mobile: '',
            dataSource: [],
            squadName:''
        }
    }



    componentDidMount() {
        log("Debug", "UserProfile screen is loaded");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                // console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                db.profileList().then((data1) => {
                    // console.warn("data" + JSON.stringify(data1))
                    // console.warn("Length" + data1.length)
                    if (data1.length == 0) {
                        // console.warn("Empty")
                    } else {
                        // console.warn("Go" + data1[0].empid)
                        this.setState({
                            profileInfo: data1[0],
                            empstatus: data1[0].empStatus,
                            isLoading: false,
                        });
                    }
                }).catch((err) => {
                    // console.warn("ERROR" + err);
                    this.setState({
                        isLoading: false
                    })
                })
            } else {
                // this.profile();
                this.GetStatus();
            }
        });
    }

    //validation For Mobile Number
    isValid() {
        const { mobile } = this.state;
        let valid = false;
        if (mobile.length === 0) {
            alert("Enter Mobile Number");
            log("Warn", "Mobile number should not be empty");
        }

        else if (mobile.length > 10) {
            alert("Enter Valid Number");
            log("Warn", "Mobile number should  be valid");
        }
        else if (mobile.length < 10) {
            alert("Enter Valid Number");
            log("Warn", "Mobile number should be valid");
        }
        else if (!this.mobilevalidate(mobile)) {
            alert('Invalid Phonenumber');

        }


        else {
            valid = true;
        }
        return valid;
    }
    mobilevalidate(mobile) {
        const reg = /^[0]?[6789]\d{9}$/;
        return reg.test(mobile);
    }


   
    //get project dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userName", (err, res) => {
            const userName = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {

                    fetch(API + 'squadsList.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                          
                            username: userName,


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            // console.log(responseJson)
                            if (responseJson.status == 'True') {
                                this.setState({
                                    isLoading: false,
                                    dataSource: [...responseJson.data],
                                }, function () {
                                    // In this block you can do something with new state.
                                });

                                // const data2 = [];

                                // responseJson.data.map(x => {
                                //     data2.push({ label: x.value, value: x.value })
                                // })
                                // this.setState({
                                //     data2: data2,
                                // })
                                // console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                // console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus() {
        const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("Hello" +squadName);

        AsyncStorage.getItem("userName", (err, res) => {
            const userName = res;
            console.log(res);


           
                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {

                        fetch(API + 'squadLogin.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username:userName,
                                crop: squadName,

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)
                        
                                   
                                      AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                      AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                      AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                      AsyncStorage.setItem('cropcode',tokenDetails.data.corp);
                                  
                                      this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    // this.setState({

                                    //     empstatus: empstatus
                                    // });
                                     alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
  
    }
    // Update Status of Employee end

    render() {
        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }

        // let data2 = [{ value: 'commericial', }, { value: 'residencial', }];
        return (
            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>Projects</Title>
                    </Body>
                    <Right>
                        {/* <Text style={{ color: 'white' }} onPress={() => this.props.navigation.navigate('UserPassword')}>{CHANGEPASSWORD}</Text> */}
                        </Right>

                </Header>
                <Content>

                    <View style={{ padding: 25 }}>
                        <View style={{ justifyContent: 'center', alignItems: 'center', height: hp('25%') }}>
                          
                        <Text>Select Project to change</Text>
                        </View>
                        <View style={{  height: hp('30%') }}>
                       
                       <Picker
                        selectedValue={this.state.squadName}
                        // onChangeText={(itemValue) => { this.UpdateStatus(itemValue) }}

                        onValueChange={(itemValue, itemIndex) => this.setState({ squadName: itemValue })} >

                        {/* onValueChange={(itemValue, itemIndex) => {this.UpdateStatus({ squadName: itemValue })}} > */}

                        {this.state.dataSource.map((item, key) => (
                            <Picker.Item label={item.value} value={item.value} key={key} />)
                        )}

                    </Picker>
                    <TouchableOpacity onPress={this.UpdateStatus.bind(this)} style={{ backgroundColor: '#00A2C1', borderRadius: 5, height: 30, alignItems: "center", justifyContent: 'center',marginTop:30 }}>
                                    <Text style={{ color: 'white' }}>Save</Text>
                                </TouchableOpacity>



                          



                          

                       
                          
                        </View>
                        





                    </View>
                </Content>

            </Container>
        );
    }
}

const styles = StyleSheet.create({
    submit: {
        flex: 1,
        ...Platform.select({
            ios: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 10
            },
            android: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 70
            },
        }),
    },
    mobile: {
        flex: 1,
        ...Platform.select({
            ios: {
                marginTop: 12
            },
            android: {

            },
        }),
    },
    role: {
        flex: 1,
        ...Platform.select({
            ios: {
                flexDirection: 'row', marginTop: 10
            },
            android: {
                flexDirection: 'row',
                paddingTop: 10,

            },
        }),
    },

});
const pickerSelectStyles = StyleSheet.create({
    inputIOS: {
        fontSize: 2,
        paddingVertical: 12,
        paddingHorizontal: 10,
        borderWidth: 1,
        borderColor: 'blue',
        borderRadius: 4,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
    inputAndroid: {
        fontSize: 3,
        paddingHorizontal: 10,
        paddingVertical: 8,
        borderWidth: 0.5,
        borderColor: 'purple',
        borderRadius: 8,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
});
